/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Drawing;
using System.Threading;
using System.Collections;


namespace symmetry
{
	/// <summary>
	/// Summary description for Recognizer.
	/// </summary>
	public class Recognizer
	{
		
		
		//TO je konstruktor
		public Recognizer()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		
		
		public Point addRecog(Stroke1 s1) //vrnemo razdaljo toke do premice dobljene z lin. reg. okoli vsake toke   
		{                                 // Toke, kjer dobimo za razdaljo Nan, imajo tukaj vrednost -2
			
			Point pt1,pt2 = new Point();
			int i1,i2=0,Sxy,SxSy,Sx,Sy,stevecD,stevecG,n;
			double k = 0.0,t = 0.0,x2S,Sx2,y2S=0,Sy2=0,r,d2 = 0.0,max = 0,min = 1000;
		 	

			for (i1=0; i1 < s1.numberOfPoints(); i1++)  //za vsako toko izraunamo premico linearne regresije okoliskih tock  
			{
				if (s1.numberOfPoints()<16) 
				{ 
					stevecD=0; 
					stevecG=s1.numberOfPoints()-1; 
					n=s1.numberOfPoints(); 
				}
				else if (i1<15 && (i1+15 >= s1.numberOfPoints())) 
				{   
					stevecD=0;
					stevecG=s1.numberOfPoints()-1;
					n = s1.numberOfPoints();
				}
				else if (i1<15) 
				{ 
					stevecD=0; 
					stevecG=i1+15; 
					n=stevecG+1;
				}  //pripravimo intervale okolice toke
				else if (i1>=s1.numberOfPoints()-15) 
				{
					stevecD=i1-15; 
					stevecG=s1.numberOfPoints()-1; 
					n=stevecG-stevecD+1;
				}
				else { 
					stevecD=i1-15; 
					stevecG=i1+15; 
					n=31;
				}
				//System.Console.WriteLine("stevecD: {0}, stevecG: {1} in n: {2}, i1: {3}", stevecD, stevecG, n, i1);
				
				
				Sxy=0; SxSy=0; Sx=0; Sy=0;
				x2S=0; Sx2=0; y2S=0; Sy2=0;
				for (i2=stevecD; i2 <= stevecG; i2++)    //racunamo vrednosti za koef. premice
				{
					pt1=s1.returnElement(i2);

					Sxy = Sxy + (pt1.X * pt1.Y);
					Sx = Sx + pt1.X;
					Sy = Sy + pt1.Y;
					x2S = x2S + Math.Pow(pt1.X,2); 
					y2S = y2S + Math.Pow(pt1.Y,2);

				}
		    
				SxSy= Sx * Sy;
				Sx2 = Math.Pow(Sx,2);
				Sy2 = Math.Pow(Sy,2);

				k= ((n*Sxy) - SxSy)/((n*x2S)-Sx2);  //y = k*x + t : nova enacba premice
				t= (Sy-(k*Sx))/n;
				r= ((n*Sxy)-SxSy)/(Math.Sqrt(((n*x2S)-Sx2)*((n*y2S)-Sy2))); //correlation coefficient
			   
				//System.Console.WriteLine("tocka:{0}, k:{1} //t:{2} //", i1, k, t);

				//razdalja tocke pt1 do premice dobljene z linearno regresijo
				pt1=s1.returnElement(i1);
				d2=(Math.Abs(k*pt1.X - pt1.Y + t))/(Math.Sqrt(Math.Pow(k,2) + 1));
				
				
				if (!(d2==d2)) s1.addRecognition(-2);  //detekcija za 'NaN'
				else 
				{
					s1.addRecognition(d2);
					if ((max < d2)&&(max > 0))
						pt2 = s1.returnElement(i1);  //toka z maksimalnim odmikom

					max=Math.Max(max,d2);
					min=Math.Min(min,d2);
				}
				

 			}//for 
			
			/*	for(i1=0; i1 < s1.numberOfPoints(); i1++) //izpisemo vse razdalje tock do ustrezne premice
				{	
					pt1=s1.returnElement(i1);
					System.Console.WriteLine("Oddaljenost tocke {0}:({1},{2}) do premice je {3}",i1,pt1.X,pt1.Y,s1.returnRecognition(i1));
						

				}
				System.Console.WriteLine(" Max je {0} in min je {1} ",max,min);           
				System.Console.WriteLine("tocka kota je ({0},{1})", pt2.X, pt2.Y);    
			 */
			return pt2;
		
		}	//addRecog
		//------------------------------------------------------------------------------------------
		
		public void addRecog2000(Stroke1 s1, int neighbor) //vrnemo razdaljo toke do premice dobljene z lin. reg. okoli vsake toke   
		{                                 // Toke, kjer dobimo za razdaljo Nan, imajo tukaj vrednost -2
			
			Point pt1,pt2 = new Point();
			int i1,i2=0,Sxy,SxSy,Sx,Sy,stevecD,stevecG,n;
			double k = 0.0,t = 0.0,x2S,Sx2,y2S=0,Sy2=0,r,d2 = 0.0,max = 0,min = 1000;
		 	
		    
            
			for (i1=0; i1 < s1.numberOfPoints(); i1++)  //za vsako toko izraunamo premico linearne regresije okoliskih tock  
			{
				//pripravimo intervale okolice toke
				if (s1.numberOfPoints()<neighbor+1) //ce je tock stroka manj kot pa okolice ki jo pregledujemo
				{ 
					stevecD=0; 
					stevecG=s1.numberOfPoints()-1; 
					n=s1.numberOfPoints(); 
				}  
				else if (i1<neighbor && (i1+neighbor >= s1.numberOfPoints())) 
				{   //smo na zacetku intevala in je vseh tock manj kot 2*neighbor
					stevecD=0;
					stevecG=s1.numberOfPoints()-1;
					n = s1.numberOfPoints();
				}
				else if (i1<neighbor) //ce je i1 < kot stevilo neighbor in je tock vec ali enako kot 2*neighbor  
				{	
					stevecD=0; 
					stevecG=i1+neighbor; 
					n=stevecG+1;} 
				else if (i1>=s1.numberOfPoints()-neighbor) 
				{
					stevecD=i1-neighbor; 
					stevecG=s1.numberOfPoints()-1; 
					n=stevecG-stevecD+1;
				}
				else 
				{  //nismo omejeni v obe smeri 
					stevecD=i1-neighbor; 
					stevecG=i1+neighbor; 
					n=2*neighbor+1;
				} 
				//System.Console.WriteLine("stevecD: {0}, stevecG: {1} in n: {2}, i1: {3}", stevecD, stevecG, n, i1);

				Sxy=0; SxSy=0; Sx=0; Sy=0;
				x2S=0; Sx2=0; y2S=0; Sy2=0;
				
				for (i2=stevecD; i2 <= stevecG; i2++)    //racunamo vrednosti za koef. premice
				{
					pt1=s1.returnElement(i2);
                    
                    Sxy = Sxy + (pt1.X * pt1.Y);
					Sx = Sx + pt1.X;
					Sy = Sy + pt1.Y;
					x2S = x2S + Math.Pow(pt1.X,2); 
					y2S = y2S + Math.Pow(pt1.Y,2);

				}
		   
				SxSy= Sx * Sy;
				Sx2 = Math.Pow(Sx,2);
				Sy2 = Math.Pow(Sy,2);

				k= ((n*Sxy) - SxSy)/((n*x2S)-Sx2);  //y = k*x + t : nova enacba premice
				t= (Sy-(k*Sx))/n;
				r= ((n*Sxy)-SxSy)/(Math.Sqrt(((n*x2S)-Sx2)*((n*y2S)-Sy2))); //correlation coefficient
			   
				//System.Console.WriteLine("tocka:{0}, k:{1} //t:{2} //", i1, k, t);

				//razdalja tocke pt1 do premice dobljene z linearno regresijo
				pt1=s1.returnElement(i1);
				d2=(Math.Abs(k*pt1.X - pt1.Y + t))/(Math.Sqrt(Math.Pow(k,2) + 1));
				
				
				if (!(d2==d2)) s1.addRecognition(-2);  //detekcija za 'NaN'
				else 
				{
					s1.addRecognition(d2);
					max=Math.Max(max,d2);
					min=Math.Min(min,d2);
				}
				
    		}//for 
			/*
				for(i1=0; i1 < s1.numberOfPoints(); i1++) //izpisemo vse razdalje tock do ustrezne premice
				{	
					pt1=s1.returnElement(i1);
					//System.Console.WriteLine("Oddaljenost tocke {0}:({1},{2}) do premice je {3}",i1,pt1.X,pt1.Y,s1.returnRecognition(i1));
				}
				System.Console.WriteLine(" Max je {0} in min je {1} ",max,min);           
			*/	   
		}	//addRecog

		//-------------------------------------------------------------------------------

		public void getAngle(Stroke1 st1, int neighbor) //raunamo kot med dvema daljicama (AB,BC), katerih krajia so tri sosednje toke (A,B,C)
		{                                 // Koti kjer dobimo 'Nan'imajo vrednost -1
			// 'neighbor' je razdalja do sosednje toke (po tevilu zajetih tok) 
			Point pMedium,pNext,pPrevious,pNext2,pPrevious2;
			int i1;
			double dNext,dPrevious,fi,scalarP, degreeFi;
			pNext2= new Point();  //koordinate vektorjev v izhodiu
			pPrevious2 = new Point();
             
   			for (i1=0; i1 < st1.numberOfPoints(); i1++) 
			{
				//System.Console.WriteLine("tockA: {0}, tock: {1}",st1.numberOfPointsA(),st1.numberOfPoints()); 
				if ((i1 <= (neighbor-1))||(i1 >= (st1.numberOfPoints()-neighbor))) //zaetne in konne toke imata kot 0
				{
					st1.addRecognitionAngle(180);  
				}
				else 
				{  // vse ostale toke

					pMedium=st1.returnElement(i1);
					pPrevious=st1.returnElement(i1-neighbor);
					pNext=st1.returnElement(i1+neighbor);
                    
					//doline obeh vektorjev
					dNext = Math.Sqrt((Math.Pow(pNext.X-pMedium.X,2))+(Math.Pow(pNext.Y-pMedium.Y,2)));
					dPrevious = Math.Sqrt((Math.Pow(pPrevious.X-pMedium.X,2))+(Math.Pow(pPrevious.Y-pMedium.Y,2)));
                    
					//koordinate vektorjev, ko jih postavimo v izhodie
					pNext2.X = pNext.X - pMedium.X; 
					pNext2.Y = pNext.Y - pMedium.Y;
					pPrevious2.X = pPrevious.X - pMedium.X;
					pPrevious2.Y = pPrevious.Y - pMedium.Y;

					scalarP=pNext2.X*pPrevious2.X + pNext2.Y*pPrevious2.Y;  //skalarni produkt vektorjev
					fi=Math.Acos(scalarP/(dNext*dPrevious));  //fi bo v radianih
                    
					degreeFi=(fi*360)/(2*Math.PI);  //pretvorba radianov v stopinje
                    
					
					//System.Console.WriteLine("Kot fi(2) znasa: {0}({1})", fi, degreeFi);  //Izpis vseh kotov
					if (!(fi==fi)) 
					{
						//System.Console.WriteLine("To je nestevilo");  //detekcija za NaN
						st1.addRecognitionAngle(-1);
					}
					else st1.addRecognitionAngle(degreeFi);
					
  			     }  //else	 
			     
		     } //for i1
		}  //getAngle

		public void getSpeed(Stroke1 st1, int d)
		{	
			int i1;
			double vel,t1,t2,distance;
			Point pMedium, pPrevious;
			
			for (i1=0; i1 < st1.numberOfPoints(); i1++) 
			{

				if (i1<=d-1) //zaetne toke imajo hitrost -1
				{
					st1.addRecognitionSpeed(-1);  
				}
				else 
				{
			        pMedium=st1.returnElement(i1);
					pPrevious=st1.returnElement(i1-d);
					distance = Math.Sqrt((Math.Pow(pPrevious.X-pMedium.X,2))+(Math.Pow(pPrevious.Y-pMedium.Y,2)));

					t1=st1.returnTimeOfElement(i1-d);
					t2=st1.returnTimeOfElement(i1);
					vel=distance/(t2-t1);
					st1.addRecognitionSpeed(vel);

					//System.Console.WriteLine("Hitrost v tocki {0} je {1}",i1,vel);
				} //else
			}  //for

    	} //getSpeed

		public void getAcc(Stroke1 st1, int d)
		{
			double acc,v1,v2,t1,t2;
			int i1;
			

			for (i1=0; i1 < st1.numberOfPoints(); i1++) 
			{
				if (i1<=d-1) //zaetne toke imajo pospeek 0
				{
					st1.addRecognitionAcc(0);  
				}
				else 
				{
					v1=st1.returnRecognitionSpeed(i1);
					v2=st1.returnRecognitionSpeed(i1-d);
					t1=st1.returnTimeOfElement(i1-d);
					t2=st1.returnTimeOfElement(i1);
					acc=(v1-v2)/(t2-t1);
					st1.addRecognitionAcc(acc);

					//System.Console.WriteLine("Hitrost v tocki {0} je {1}(pospeek:{2})",i1,st1.returnRecognitionSpeed(i1),acc);
				} //else	     
			} //for
		
		}  //getAcc


//-----------------------------------------------------------------------------------------
		//funkcije za sprotno raunanje atributov
		public void getAngleS(Stroke1 st1, int neighbor) //raunamo kot med dvema daljicama (AB,BC), katerih krajia so tri sosednje toke (A,B,C)
		{                                 // Koti kjer dobimo 'Nan'imajo vrednost -1
			// 'neighbor' je razdalja do sosednje toke (po tevilu zajetih tok) 
			Point pMedium,pNext,pPrevious,pNext2,pPrevious2;
			int i1,rr;
			double dNext,dPrevious,fi,scalarP, degreeFi;
			pNext2= new Point();  //koordinate vektorjev v izhodiu
			pPrevious2 = new Point();
             
			if (st1.numberOfPoints()-neighbor-1 < 0) 
				rr=0;
			else rr=st1.numberOfPoints()-neighbor-1;

			for (i1=rr; i1 < st1.numberOfPoints(); i1++) 
			{                                                         
				//System.Console.WriteLine("tockA: {0}, tock: {1}",st1.numberOfPointsA(),st1.numberOfPoints()); 
				if ((i1<=neighbor-1)||i1>=st1.numberOfPoints()-neighbor) //konne toke imajo kot 0
				{
					st1.addRecognitionAngle(180);  
				}
				else 
				{  // vse ostale toke
                    					
					pMedium=st1.returnElement(i1);
					pPrevious=st1.returnElement(i1-neighbor);
					pNext=st1.returnElement(i1+neighbor);
                    
					//doline obeh vektorjev
					dNext = Math.Sqrt((Math.Pow(pNext.X-pMedium.X,2))+(Math.Pow(pNext.Y-pMedium.Y,2)));
					dPrevious = Math.Sqrt((Math.Pow(pPrevious.X-pMedium.X,2))+(Math.Pow(pPrevious.Y-pMedium.Y,2)));
                    
					//koordinate vektorjev, ko jih postavimo v izhodie
					pNext2.X = pNext.X - pMedium.X; 
					pNext2.Y = pNext.Y - pMedium.Y;
					pPrevious2.X = pPrevious.X - pMedium.X;
					pPrevious2.Y = pPrevious.Y - pMedium.Y;

					scalarP=pNext2.X*pPrevious2.X + pNext2.Y*pPrevious2.Y;  //skalarni produkt vektorjev
					fi=Math.Acos(scalarP/(dNext*dPrevious));  //fi bo v radianih
                    
					degreeFi=(fi*360)/(2*Math.PI);  //pretvorba radianov v stopinje
                    
					
					//System.Console.WriteLine("Kot fi znasa: {0}({1})", fi, degreeFi);  //Izpis vseh kotov
					if (!(fi==fi)) 
					{
						//System.Console.WriteLine("To je nestevilo");  //detekcija za NaN
						st1.addRecognitionAngle(-1);
					}
					else st1.ChangeRecognitionAngle(degreeFi,i1); //spremenimo iz 180 stopinj v pravo vrednost
						//st1.addRecognitionAngle(degreeFi);
					
				}  //else	 
			     
			} //for i1

		}  //getAngle


		public void addRecog2000S(Stroke1 s1, int neighbor) //vrnemo razdaljo toke do premice dobljene z lin. reg. okoli vsake toke   
		{                                 // Toke, kjer dobimo za razdaljo Nan, imajo tukaj vrednost -2
			
			Point pt1,pt2 = new Point();
			int i1,i2=0,Sxy,SxSy,Sx,Sy,stevecD,stevecG,n,rr;
			double k = 0.0,t = 0.0,x2S,Sx2,y2S=0,Sy2=0,r,d2 = 0.0,max = 0,min = 1000;
		 	
			if (s1.numberOfPoints()-neighbor-1 < 0)
                rr=0;
			else
				rr=s1.numberOfPoints()-neighbor-1;

			for (i1=rr; i1 < s1.numberOfPoints(); i1++)  //za vsako toko izraunamo premico linearne regresije okoliskih tock  
			{
				//pripravimo intervale okolice toke
				if (s1.numberOfPoints()<neighbor+1) //ce je tock stroka manj kot pa okolice ki jo pregledujemo
				{ 
					stevecD=0; 
					stevecG=s1.numberOfPoints()-1; 
					n=s1.numberOfPoints(); 
				}  
				else if (i1<neighbor && (i1+neighbor >= s1.numberOfPoints())) 
				{   //smo na zacetku intevala in je vseh tock manj kot 2*neighbor
					stevecD=0;
					stevecG=s1.numberOfPoints()-1;
					n = s1.numberOfPoints();
				}
				else if (i1<neighbor) //ce je i1 < kot stevilo neighbor in je tock vec ali enako kot 2*neighbor  
				{	
					stevecD=0; 
					stevecG=i1+neighbor; 
					n=stevecG+1;} 
				else if (i1>=s1.numberOfPoints()-neighbor) 
				{
					stevecD=i1-neighbor; 
					stevecG=s1.numberOfPoints()-1; 
					n=stevecG-stevecD+1;
				}
				else 
				{  //nismo omejeni v obe smeri 
					stevecD=i1-neighbor; 
					stevecG=i1+neighbor; 
					n=2*neighbor+1;
				} 
				//System.Console.WriteLine("stevecD: {0}, stevecG: {1} in n: {2}, i1: {3}", stevecD, stevecG, n, i1);

				Sxy=0; SxSy=0; Sx=0; Sy=0;
				x2S=0; Sx2=0; y2S=0; Sy2=0;
				
				for (i2=stevecD; i2 <= stevecG; i2++)    //racunamo vrednosti za koef. premice
				{
					pt1=s1.returnElement(i2);
                    
					Sxy = Sxy + (pt1.X * pt1.Y);
					Sx = Sx + pt1.X;
					Sy = Sy + pt1.Y;
					x2S = x2S + Math.Pow(pt1.X,2); 
					y2S = y2S + Math.Pow(pt1.Y,2);

				} //for
		   
				SxSy= Sx * Sy;
				Sx2 = Math.Pow(Sx,2);
				Sy2 = Math.Pow(Sy,2);

				k= ((n*Sxy) - SxSy)/((n*x2S)-Sx2);  //y = k*x + t : nova enacba premice
				t= (Sy-(k*Sx))/n;
				r= ((n*Sxy)-SxSy)/(Math.Sqrt(((n*x2S)-Sx2)*((n*y2S)-Sy2))); //correlation coefficient
			   
				//System.Console.WriteLine("tocka:{0}, k:{1} //t:{2} //", i1, k, t);

				//razdalja tocke pt1 do premice dobljene z linearno regresijo
				pt1=s1.returnElement(i1);
				d2=(Math.Abs(k*pt1.X - pt1.Y + t))/(Math.Sqrt(Math.Pow(k,2) + 1));
				
				
				if (s1.pointRecognition.Count-1 < i1) //za novo tocko dodamo novo vrednost v seznam recog.
				{ //potem tega elementa se ni
					//System.Console.WriteLine("Dodani: {0}({1})",d2,i1);
					if (!(d2==d2)) s1.addRecognition(-2); //detekcija za 'NaN'
					else 
					{
						s1.addRecognition(d2);  
					}
				}
				else //ce je bila vrednost ze izracunana, jo samo popravimo 
				{
					//System.Console.WriteLine("Zamenjani: {0}({1})",d2,i1);
					if (!(d2==d2)) s1.ChangeRecognition(-2,i1); //detekcija za 'NaN'
					else s1.ChangeRecognition(d2,i1);
				}
				max=Math.Max(max,d2);
				min=Math.Min(min,d2);
				
				//System.Console.WriteLine("mamo i1: {0} in vrednost:{1}",i1,d2);				
			}//for 

			/*
				for(i1=0; i1 < s1.numberOfPoints(); i1++) //izpisemo vse razdalje tock do ustrezne premice
				{	
					pt1=s1.returnElement(i1);
					//System.Console.WriteLine("Oddaljenost tocke {0}:({1},{2}) do premice je {3}",i1,pt1.X,pt1.Y,s1.returnRecognition(i1));
				}
				System.Console.WriteLine(" Max je {0} in min je {1} ",max,min);           
			*/	   

		}	//addRecog

		public void getSpeedS(Stroke1 st1, int d)
		{	
			
			double vel,t1,t2,distance;
			Point pMedium, pPrevious;
			
			//if (st1.numberOfPoints()-d-1 < 0 ) rr=0;
			//else rr=st1.numberOfPoints()-d-1;

			//for (i1=rr; i1 < st1.numberOfPoints(); i1++) 
			//{

				if (st1.numberOfPoints()<=d) //zaetne toke imajo hitrost -1
				{
					st1.addRecognitionSpeed(-1);  
				}
				else 
				{
					pMedium=st1.returnElement(st1.numberOfPoints()-1);
					pPrevious=st1.returnElement(st1.numberOfPoints()-d-1);
					distance = Math.Sqrt((Math.Pow(pPrevious.X-pMedium.X,2))+(Math.Pow(pPrevious.Y-pMedium.Y,2)));

					t1=st1.returnTimeOfElement(st1.numberOfPoints()-d-1);
					t2=st1.returnTimeOfElement(st1.numberOfPoints()-1);
					vel=distance/(t2-t1);
					st1.addRecognitionSpeed(vel);

					//System.Console.WriteLine("Hitrost v tocki {0} je {1}",st1.numberOfPoints(),vel);
				} //else
			//}  //for

		} //getSpeed
}	//Recognizer


		
	
//-----------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------
	
public class Recognizer3
{
			
	
	public void cornerDetector(double Dmin,double Dmax,double AlfaMax,Stroke1 st)
	{

		double distanceA = 0,distanceB = 0,distanceC = 0,alfa = 0,minAlfa = AlfaMax;
		Point p1,p2,p3;
		int i,j,k;
			

		st.addRecognition(0);
		
		for(i = 1;i < st.numberOfPoints()-1;i++)
		{
			j = 1;
			minAlfa = AlfaMax;
			p2 = st.returnElement(i);
		
			while(((i-j) >= 0)&&((i+j) <st.numberOfPoints()))
			{
				p1 = st.returnElement(i-j);
				p3 = st.returnElement(i+j);				
                  
				distanceA  = pointDistance(p2,p3);
				distanceB = pointDistance(p1,p2);
				distanceC = pointDistance(p1,p3);
				alfa = angleBetweenPoints(distanceA,distanceB,distanceC);
			

				if(Math.Pow(Dmin,2) <= Math.Pow(distanceA,2)&&
					Math.Pow(distanceA,2)<= Math.Pow(Dmax,2) &&
					Math.Pow(Dmin,2) <= Math.Pow(distanceB,2)&&
					Math.Pow(distanceB,2)<= Math.Pow(Dmax,2)&&	
					(alfa <=  AlfaMax))
				{
					minAlfa = Math.Min(minAlfa,alfa);

					
				}
				else
				{
					if(minAlfa == AlfaMax)
						st.addRecognition(0);
					else
						st.addRecognition(Math.PI-minAlfa);

					break;
				}

				j++;	
				if(((i-j) < 0)||((i+j) >= st.numberOfPoints()))
				{
					st.addRecognition(Math.PI-minAlfa);
					break;
				}
			}
				

		}
		st.addRecognition(0);

			
		
		for(i = 0;i<st.numberOfPoints();i = i + 10)
		{
			k = i;
			
			for(j=i+1;j < st.numberOfPoints() && j < i+9;j++)
			{
				if(st.returnRecognition(k) > st.returnRecognition(j))
				{
					st.changeRecognition(k,0);
					k = j;
				}
				else
					st.changeRecognition(j,0);

			}
		}
			
	}
		

	private double pointDistance(Point p1,Point p2)
	{

		return Math.Sqrt(Math.Pow(p2.X-p1.X,2)+Math.Pow(p2.Y-p1.Y,2));

	}

	private double angleBetweenPoints(double a,double b,double c)
	{

		return Math.Acos((a*a+b*b-c*c)/(2*a*b));

	}
       	
	
}//Recognizer3
//-----------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------


public class Recognizer2
{
	
	private Point lastVektor = Point.Empty;
	public bool aliNarsiemOdvisnost = false;
	public static int odsopanjeOdVzporednosti = 10;
	public static double ocutlivostVelikosti = 0.1;
	


		
	public Recognizer2()
	{
			
		
	}

	~Recognizer2()
	{
		

	}


	public int addPoint(Point last,Point first,double time)		//dodamo novo tocko in pogledamo e je treba spremeniti smer
	{
		double angle = 0;
		int x = 0 ,y = 0;
		double prag = 0;

		/*
			System.Console.WriteLine("last = "+last.X+","+last.Y);
			System.Console.WriteLine("first = "+first.X+","+first.Y);
	*/

		x = last.X - first.X;
		y = last.Y - first.Y;

		/*	if(time > 0.4)
				prag = Math.PI/8;
			else if(time > 0.1 && time < 0.4)
				prag = Math.PI/8;
			else
				prag = Math.PI/5;
	*/
		prag = Math.PI/10;

		if((Math.Abs(x)+Math.Abs(y)) <= 5)
			prag = Math.PI/1.9;
	//	else
	//		prag = Math.PI/10;
		
		
		if(lastVektor.Equals(Point.Empty))
		{
			lastVektor = new Point(x,y);
			return 1;
		}
		else
		{
			angle =  klasificiraj(last,x,y);
			if(angle >= prag)
			{
				/*
						System.Console.WriteLine("lastX = "+lastVektor.X);
						System.Console.WriteLine("lastY = "+lastVektor.Y);
						System.Console.WriteLine("X = "+x);
						System.Console.WriteLine("Y = "+y);
						System.Console.WriteLine("angle = "+(angle/Math.PI)*180+"\n");
					*/
				lastVektor.X = x;
				lastVektor.Y = y;
				return 1;

			}
			else 
				return 0;

		}
					
	}

	public double klasificiraj(Point last,int x, int y)
	{
		Point p1 = new Point(last.X+x,last.Y+y);
		Point p2 = new Point(last.X+lastVektor.X ,last.Y+lastVektor.Y);	
		
		double disA = 0,disB = 0,disC = 0 ;

		disA = pointDistance(last,p1);
		disB =  pointDistance(last,p2);
		disC =  pointDistance(p1,p2);
 			
		return angleBetweenPoints(disA,disB,disC);
     
	}

	public double pointDistance(Point p1,Point p2)
	{

		return Math.Sqrt(Math.Pow(p2.X-p1.X,2)+Math.Pow(p2.Y-p1.Y,2));

	}

	public double angleBetweenPoints(double a,double b,double c)
	{

		return Math.Acos((a*a+b*b-c*c)/(2*a*b));

	}

	public bool vrniPredznak(int x1,int x2)
	{
		if((x1 >= 0) && (x2 >= 0))
			return true;
		else if((x1 <= 0) && (x2 <= 0))
			return true;
		
		else
			return false;


	}


	public double calcAngle(Point p1,Point p2,Point p3)	//vrne kot med tockami v stopinjah
	{
	
			double a = 0,b = 0,c = 0,angle = 0;

			a = pointDistance(p1,p2);
			b = pointDistance(p2,p3);
			c = pointDistance(p1,p3);
	
			angle = angleBetweenPoints(a,b,c);
			angle = (angle/Math.PI)*180;

			return angle;
	
	}

	
	public Stroke1 zaokroziKote(Stroke1 st,Graphics g)
	{
	
		int i = 0,j = 0;
		Point p1,p2,p3,p4,p5;
		double x = 0,y = 0;
		double x1 = 0,y1 = 0;
		double pomozna = 0;
		double distance1 = 0,distance2 = 0;
		ArrayList indeksi = new ArrayList() ;
		ArrayList  prvePovezave = new ArrayList();
		Pen pp = new Pen(Color.GreenYellow,2);
		int transX = 0,transY = 0;
		
		
		p5 = new Point();
		
		for(i = 0;i<st.numberOfPoints()-1;i++)
		{
			if(st.returnElement(i).Equals(st.returnElement(i+1)))
				st.removePoint(i);
		}

		System.Console.WriteLine("----------------------------------");

		for(i = 0;i<st.numberOfPoints()-1;i++)
		{
		
			p1 = st.returnElement(i);
			p2 = st.returnElement(i+1);
			

			x = p2.X - p1.X;
			y = p2.Y - p1.Y;
			
			
            
			distance1 = Math.Sqrt(x*x+y*y);

		//	x = x/distance1;
		//  y = y/distance1;



			for(j = i+1;j < st.numberOfPoints()-1;j++)
			{

				
				if(!indeksi.Contains(j))
				{
                    				
					p3 = st.returnElement(j);
					p4 = st.returnElement(j+1);
					

					x1 = p4.X - p3.X;
					y1 = p4.Y - p3.Y;
					distance2 = Math.Sqrt(x1*x1+y1*y1);

				//	x1 = x1/distance2;
			//		y1 = y1/distance2;

							
					
					p5.X = p1.X + (int)x1;
					p5.Y = p1.Y + (int)y1;
				
				
					
					pomozna = x*x1+y*y1;
					pomozna = pomozna/(distance1*distance2);
					pomozna = Math.Acos(pomozna);
					pomozna = (pomozna/Math.PI)*180;

					
							
						
							
					if((pomozna < odsopanjeOdVzporednosti) || (pomozna > (180-odsopanjeOdVzporednosti)))
					{

						if(pomozna > (180-odsopanjeOdVzporednosti))
						{
							double velikost = 0;
												
							
							velikost = distance2/distance1;
							if(Math.Abs(velikost-1) <= ocutlivostVelikosti)
								velikost = 1;
							
					

							p4.X = p3.X-(int)(x*(velikost));
							p4.Y = p3.Y-(int)(y*(velikost));
									
						}
						else
						{
							double velikost = 0;
												
							velikost = distance2/distance1;
							if(Math.Abs(velikost-1) <= ocutlivostVelikosti)
								velikost = 1;


							p4.X = p3.X+(int)(x*(velikost));
							p4.Y = p3.Y+(int)(y*(velikost));
							
						}
						

					
							
						x1 = p4.X - st.returnElement(j+1).X;
						y1 = p4.Y - st.returnElement(j+1).Y;

					//	transX = (int)x1 +transX;
					//	transY = (int)y1 +transY;
					
						for(int k = j+2;k <st.numberOfPoints();k++)
						{
							if(k != j+1)
							{
								p3 = st.returnElement(k);
								p3.Offset((int)x1,(int)y1);
								st.changePoint(p3,k);
							}
						
						}
									
					
					    indeksi.Add(j);
						prvePovezave.Add(i);
						
						st.changePoint(p4,j+1);
					
					}
				 
				}
			
			
			}
		
			
		}

		for(int k = 0;k <st.numberOfPoints();k++)
		{
		
			p3 = st.returnElement(k);
			if(p3.X < 0)
				transX = transX + p3.X;
			if(p3.Y < 0)
				transY = transY + p3.Y;
			
						
		}

		
		for(int k = 0;k <st.numberOfPoints();k++)
		{

				p3 = st.returnElement(k);
				p3.Offset(-transX,-transY);
				st.changePoint(p3,k);
						
		}

		if(aliNarsiemOdvisnost)
			for(int k = 0;k<indeksi.Count;k++)
			{
				i = (int)prvePovezave[k];
				j = (int)indeksi[k];
				p3 = new Point();
					p3.X = (int)(st.returnElement(i).X+st.returnElement(i+1).X)/2;
					p3.Y = (int)(st.returnElement(i).Y+st.returnElement(i+1).Y)/2;
					st.vzporednePovezave.Add(p3);
					p3.X = (int)(st.returnElement(j).X+st.returnElement(j+1).X)/2;
					p3.Y = (int)(st.returnElement(j).Y+st.returnElement(j+1).Y)/2;
					st.vzporednePovezave.Add(p3);
			}
		
		
		prvePovezave.Clear();
		indeksi.Clear();

		return st;
	
	}

	public Stroke1 zaokroziKoteGledeNaSosede(Stroke1 st,Strokes1 allSt,Graphics g)
	{
	
		int i = 0,j = 0,f = 0;
		Point p1,p2,p3,p4,p5;
		double x = 0,y = 0;
		double x1 = 0,y1 = 0;
		double pomozna = 0;
		double distance1 = 0,distance2 = 0;
		ArrayList indeksi = new ArrayList() ;
		ArrayList  prvePovezave = new ArrayList();
		ArrayList kateriStroke = new ArrayList();
		Pen pp = new Pen(Color.GreenYellow,2);
		int transX = 0,transY = 0;
		Stroke1 str;
	
		
		p5 = new Point();
		
		for(i = 0;i<st.numberOfPoints()-1;i++)
		{
			if(st.returnElement(i).Equals(st.returnElement(i+1)))
				st.removePoint(i);
		}

	

		for(f = 0;f<st.sosednjiStroki.Count;f++)
		{
			str = (Stroke1)(allSt.returnStrokeObject((int)st.sosednjiStroki[f]));
			for(i = 0;i<str.numberOfPoints()-1;i++)
			{
			
				p1 = str.returnElement(i);
				p2 = str.returnElement(i+1);
				

				x = p2.X - p1.X;
				y = p2.Y - p1.Y;
				
				
	            
				distance1 = Math.Sqrt(x*x+y*y);

			


				for(j = 0;j < st.numberOfPoints()-2;j++)
				{

					
					if(!indeksi.Contains(j))
					{
	                    				
						p3 = st.returnElement(j);
						p4 = st.returnElement(j+1);
						

						x1 = p4.X - p3.X;
						y1 = p4.Y - p3.Y;
						distance2 = Math.Sqrt(x1*x1+y1*y1);

														
						
						p5.X = p1.X + (int)x1;
						p5.Y = p1.Y + (int)y1;
					
						pomozna = x*x1+y*y1;
						pomozna = pomozna/(distance1*distance2);
					
						pomozna = Math.Acos(pomozna);
						pomozna = (pomozna/Math.PI)*180;

						
									
						
								
						if((pomozna < odsopanjeOdVzporednosti) || (pomozna > (180-odsopanjeOdVzporednosti)))
						{

							if(pomozna > (180-odsopanjeOdVzporednosti))
							{
								double velikost = 0;
													
								
								velikost = distance2/distance1;
								if(Math.Abs(velikost-1) <= ocutlivostVelikosti)
									velikost = 1;
								
						

								p4.X = p3.X-(int)(x*(velikost));
								p4.Y = p3.Y-(int)(y*(velikost));
										
							}
							else
							{
								double velikost = 0;
													
								velikost = distance2/distance1;
								if(Math.Abs(velikost-1) <= ocutlivostVelikosti)
									velikost = 1;


								p4.X = p3.X+(int)(x*(velikost));
								p4.Y = p3.Y+(int)(y*(velikost));
								
							}
							

						
								
							x1 = p4.X - st.returnElement(j+1).X;
							y1 = p4.Y - st.returnElement(j+1).Y;

						//	transX = (int)x1 +transX;
						//	transY = (int)y1 +transY;
						
							for(int k = j+2;k <st.numberOfPoints()-1;k++)
							{
								if(k != j+1)
								{
									p3 = st.returnElement(k);
									p3.Offset((int)x1,(int)y1);
									st.changePoint(p3,k);
								}
							
							}
										
						
							indeksi.Add(j);
							prvePovezave.Add(i);
							kateriStroke.Add(st.sosednjiStroki[f]);
							
							st.changePoint(p4,j+1);
						
						}
					 
					}
				
				
				}
			
				
			}
		}

	/*	for(int k = 0;k <st.numberOfPoints();k++)
		{
			p3 = st.returnElement(k);
			p3.Offset(-transX,-transY);
			st.changePoint(p3,k);
						
		}*/

		for(i = 0;i<st.numberOfPoints()-2;i++)
		{
			p1 = st.returnElement(i);
			p2 = st.returnElement(i+1);

			if(Math.Abs(p1.X - p2.X)< 20)
			{
				p2.X = p1.X;
				st.changePoint(p2,i+1);
			}

			if(Math.Abs(p1.Y - p2.Y)< 20)
			{
				p2.Y = p1.Y;
				st.changePoint(p2,i+1);
			}
		}

		//popravimo e zadnji dve toki
		p1 = st.returnElement(st.numberOfPoints()-2);
		p2 = st.returnElement(st.numberOfPoints()-1);

		if(Math.Abs(p1.X - p2.X)< 20)
		{
			p1.X = p2.X;
			st.changePoint(p1,st.numberOfPoints()-2);
		}

		if(Math.Abs(p1.Y - p2.Y)< 20)
		{
			p1.Y = p2.Y;
			st.changePoint(p1,st.numberOfPoints()-2);
		}

	
		int h = 0;
		Stroke1 stro;
		
		if(aliNarsiemOdvisnost)
			for(int k = 0;k<indeksi.Count;k++)
			{
				
				i = (int)prvePovezave[k];
				h = (int)kateriStroke[k];
				j = (int)indeksi[k];
				stro = allSt.returnStrokeObject(h);
				p3 = new Point();
				p3.X = (int)(stro.returnElement(i).X+stro.returnElement(i+1).X)/2;
				p3.Y = (int)(stro.returnElement(i).Y+stro.returnElement(i+1).Y)/2;
				st.vzporednePovezave.Add(p3);
				p3.X = (int)(st.returnElement(j).X+st.returnElement(j+1).X)/2;
				p3.Y = (int)(st.returnElement(j).Y+st.returnElement(j+1).Y)/2;
				st.vzporednePovezave.Add(p3);
			}

		
		
		prvePovezave.Clear();
		indeksi.Clear();
		kateriStroke.Clear();

		return st;
	
	}

	
	public Stroke1 aliJeKrivulja(Stroke1 str,Stroke1 dejanskiStorke,Graphics g)
	{
		Point p1,p2,p3;
		Point p5 = new Point();
		double distance1 = 0,distance2 = 0;
		double pomozna = 0;
		int x = 0,y = 0,x1 = 0,y1 = 0;
		int j = 0;
		double ukrivljenostKrivulje = 50;
		Pen p = new Pen(Color.Blue,2);
		Form1.krivulja = false;
		Stroke1 novi = new Stroke1();
		


		for(j = 0;j < str.numberOfPoints()-2;j++)
		{
					
				p1 = str.returnElement(j);				
				p2 = str.returnElement(j+1);
				p3 = str.returnElement(j+2);

				x = p2.X - p1.X;
				y = p2.Y - p1.Y;
				distance1 = Math.Sqrt(x*x+y*y);
			
				x1 = p3.X - p2.X;
				y1 = p3.Y - p2.Y;
				distance2 = Math.Sqrt(x1*x1+y1*y1);

							
				p5.X = p1.X + (int)x1;
				p5.Y = p1.Y + (int)y1;
						
				pomozna = x*x1+y*y1;
				pomozna = pomozna/(distance1*distance2);
						
				pomozna = Math.Acos(pomozna);
				pomozna = (pomozna/Math.PI)*180;

				System.Console.WriteLine(pomozna);

				if(pomozna < ukrivljenostKrivulje)
				{
					continue;
				}
				else 
					break;
	
		}
		System.Console.WriteLine(j+" "+str.numberOfPoints());

		j = j+2;
		if(j == str.numberOfPoints())
		{

			
		
			for(j = 0;j < dejanskiStorke.numberOfPoints();j= j+5)
			{
				dejanskiStorke.markedCornersL.Add(dejanskiStorke.returnElement(j));
			}
			

			SubDivision sb = new SubDivision();


			sb.subSampleSize =	dejanskiStorke.markedCornersL.Count;
			sb.subdivision(dejanskiStorke,3);
			

			novi.addColor(str.returnColor());
			novi.addWidth(str.returnWidth());
			str.clearStroke();

		
			for(j = 0;j < dejanskiStorke.markedCornersL.Count-1;j++)
			{
				novi.addPoint((Point)dejanskiStorke.markedCornersL[j],0);
				g.DrawLine(p,((Point)dejanskiStorke.markedCornersL[j]),(Point)(dejanskiStorke.markedCornersL[j+1]));
			}

		
			double distance = 15;
			
			
		
			for(j = 0;j < novi.numberOfPoints()-1;j++)
			{
			
				
				p1 = novi.returnElement(j);
				p2 = novi.returnElement(j+1);
				x = p2.X - p1.X;
				y = p2.Y - p1.Y;
				distance1 = Math.Sqrt(x*x+y*y);
				if(distance1 < distance)
				{
					novi.removePoint(j+1);
					j--;
				}
			}

         			

			Form1.krivulja = true;

			return novi;
		
		}
		else
			return str;

	
	}
	
			
}//Recognizer2


}//namespace symmetry



