/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace symmetry
{
	/// <summary>
	/// Summary description for Set_Forces.
	/// </summary>
	public class Set_Forces : System.Windows.Forms.Form
	{
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.NumericUpDown numericUpDown2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.NumericUpDown numericUpDown3;
		private System.Windows.Forms.NumericUpDown numericUpDown4;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.NumericUpDown numericUpDown5;
		private System.Windows.Forms.NumericUpDown numericUpDown6;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Set_Forces()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			numericUpDown1.Value = (decimal)Form1.omejitevHitrosti;
			numericUpDown2.Value = (decimal)Form1.casovniKorak;
			numericUpDown3.Value = (decimal)Form1.gKonstanta;
			numericUpDown4.Value = (decimal)Form1.smerGravSile ;
			numericUpDown5.Value = (decimal)Form1.silaCirculalWall ;
			numericUpDown6.Value = (decimal)Form1.radijCirculalWall;

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Set_Forces));
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.numericUpDown2 = new System.Windows.Forms.NumericUpDown();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.numericUpDown4 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown3 = new System.Windows.Forms.NumericUpDown();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.numericUpDown6 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown5 = new System.Windows.Forms.NumericUpDown();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).BeginInit();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).BeginInit();
			this.groupBox3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown6)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).BeginInit();
			this.SuspendLayout();
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 203);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(600, 22);
			this.statusBar1.TabIndex = 0;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			this.menuItem1.Text = "File";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Exit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label2.Location = new System.Drawing.Point(16, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 23);
			this.label2.TabIndex = 2;
			this.label2.Text = "Hitrost :";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label3.Location = new System.Drawing.Point(16, 104);
			this.label3.Name = "label3";
			this.label3.TabIndex = 3;
			this.label3.Text = "asovni korak :";
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.DecimalPlaces = 9;
			this.numericUpDown1.Location = new System.Drawing.Point(16, 64);
			this.numericUpDown1.Maximum = new System.Decimal(new int[] {
																		   1410065408,
																		   2,
																		   0,
																		   0});
			this.numericUpDown1.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   327680});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.TabIndex = 4;
			this.numericUpDown1.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 262144});
			this.numericUpDown1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown1_KeyUp);
			this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.numericUpDown2);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.numericUpDown1);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(152, 176);
			this.groupBox1.TabIndex = 5;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Parametri simulacije :";
			// 
			// numericUpDown2
			// 
			this.numericUpDown2.Location = new System.Drawing.Point(16, 136);
			this.numericUpDown2.Maximum = new System.Decimal(new int[] {
																		   1410065408,
																		   2,
																		   0,
																		   0});
			this.numericUpDown2.Name = "numericUpDown2";
			this.numericUpDown2.TabIndex = 5;
			this.numericUpDown2.Value = new System.Decimal(new int[] {
																		 100,
																		 0,
																		 0,
																		 0});
			this.numericUpDown2.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown2_KeyUp);
			this.numericUpDown2.ValueChanged += new System.EventHandler(this.numericUpDown2_ValueChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.numericUpDown4);
			this.groupBox2.Controls.Add(this.numericUpDown3);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.groupBox2.Location = new System.Drawing.Point(192, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(184, 176);
			this.groupBox2.TabIndex = 6;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Sila Gravitacije:";
			// 
			// numericUpDown4
			// 
			this.numericUpDown4.Location = new System.Drawing.Point(16, 136);
			this.numericUpDown4.Maximum = new System.Decimal(new int[] {
																		   360,
																		   0,
																		   0,
																		   0});
			this.numericUpDown4.Name = "numericUpDown4";
			this.numericUpDown4.TabIndex = 3;
			this.numericUpDown4.Value = new System.Decimal(new int[] {
																		 90,
																		 0,
																		 0,
																		 0});
			this.numericUpDown4.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown4_KeyUp);
			this.numericUpDown4.ValueChanged += new System.EventHandler(this.numericUpDown4_ValueChanged);
			// 
			// numericUpDown3
			// 
			this.numericUpDown3.DecimalPlaces = 4;
			this.numericUpDown3.Location = new System.Drawing.Point(16, 64);
			this.numericUpDown3.Maximum = new System.Decimal(new int[] {
																		   -727379968,
																		   232,
																		   0,
																		   0});
			this.numericUpDown3.Minimum = new System.Decimal(new int[] {
																		   -727379968,
																		   232,
																		   0,
																		   -2147483648});
			this.numericUpDown3.Name = "numericUpDown3";
			this.numericUpDown3.TabIndex = 2;
			this.numericUpDown3.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 -2147483648});
			this.numericUpDown3.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown3_KeyUp);
			this.numericUpDown3.ValueChanged += new System.EventHandler(this.numericUpDown3_ValueChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 104);
			this.label4.Name = "label4";
			this.label4.TabIndex = 1;
			this.label4.Text = "Smer:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(160, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Gravitacijska konstanta:";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.numericUpDown6);
			this.groupBox3.Controls.Add(this.numericUpDown5);
			this.groupBox3.Controls.Add(this.label6);
			this.groupBox3.Controls.Add(this.label5);
			this.groupBox3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.groupBox3.Location = new System.Drawing.Point(416, 8);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(168, 176);
			this.groupBox3.TabIndex = 7;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "CircularWallForce";
			// 
			// numericUpDown6
			// 
			this.numericUpDown6.Location = new System.Drawing.Point(16, 136);
			this.numericUpDown6.Maximum = new System.Decimal(new int[] {
																		   10000000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown6.Name = "numericUpDown6";
			this.numericUpDown6.TabIndex = 3;
			this.numericUpDown6.Value = new System.Decimal(new int[] {
																		 5,
																		 0,
																		 0,
																		 0});
			this.numericUpDown6.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown6_KeyUp);
			this.numericUpDown6.ValueChanged += new System.EventHandler(this.numericUpDown6_ValueChanged);
			// 
			// numericUpDown5
			// 
			this.numericUpDown5.DecimalPlaces = 4;
			this.numericUpDown5.Location = new System.Drawing.Point(16, 64);
			this.numericUpDown5.Maximum = new System.Decimal(new int[] {
																		   1000000000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown5.Minimum = new System.Decimal(new int[] {
																		   1215752192,
																		   23,
																		   0,
																		   -2147483648});
			this.numericUpDown5.Name = "numericUpDown5";
			this.numericUpDown5.TabIndex = 2;
			this.numericUpDown5.Value = new System.Decimal(new int[] {
																		 15,
																		 0,
																		 0,
																		 0});
			this.numericUpDown5.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown5_KeyUp);
			this.numericUpDown5.ValueChanged += new System.EventHandler(this.numericUpDown5_ValueChanged);
			// 
			// label6
			// 
			this.label6.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label6.Location = new System.Drawing.Point(16, 104);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(100, 24);
			this.label6.TabIndex = 1;
			this.label6.Text = "Radij:";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 32);
			this.label5.Name = "label5";
			this.label5.TabIndex = 0;
			this.label5.Text = "Sila:";
			// 
			// Set_Forces
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 225);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.statusBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Set_Forces";
			this.Text = "Set_Forces";
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).EndInit();
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).EndInit();
			this.groupBox3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown6)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		//parametri simulacije
		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			Form1.omejitevHitrosti = (float)numericUpDown1.Value;
		}

		
		private void numericUpDown1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Form1.omejitevHitrosti = (float)numericUpDown1.Value;
		}

		private void numericUpDown2_ValueChanged(object sender, System.EventArgs e)
		{
			Form1.casovniKorak = (long)numericUpDown2.Value;
		}

		private void numericUpDown2_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Form1.casovniKorak = (long)numericUpDown2.Value;
		}

		//gravitacijska konstanta
		private void numericUpDown3_ValueChanged(object sender, System.EventArgs e)
		{
			Form1.gKonstanta =  (float)numericUpDown3.Value;
		}

		private void numericUpDown3_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Form1.gKonstanta =  (float)numericUpDown3.Value;
		}

		private void numericUpDown4_ValueChanged(object sender, System.EventArgs e)
		{
		  Form1.smerGravSile =  (int)numericUpDown4.Value;
		}

		private void numericUpDown4_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			  Form1.smerGravSile =  (int)numericUpDown4.Value;
		}

		//circularWallForce

		private void numericUpDown5_ValueChanged(object sender, System.EventArgs e)
		{
			Form1.silaCirculalWall = (float)numericUpDown5.Value;
		}

		
		private void numericUpDown5_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Form1.silaCirculalWall = (float)numericUpDown5.Value;
		}

		private void numericUpDown6_ValueChanged(object sender, System.EventArgs e)
		{
			Form1.radijCirculalWall =  (int)numericUpDown6.Value;
		}

		
		private void numericUpDown6_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Form1.radijCirculalWall =  (int)numericUpDown6.Value;
		}
	

		private void menuItem2_Click(object sender, System.EventArgs e)//File -> Exit
		{
				Set_Forces.ActiveForm.Close();	
			

		}

		private void button1_Click(object sender, System.EventArgs e) //Submit
		{
			
			Form1.omejitevHitrosti = (float)numericUpDown1.Value;
			Form1.casovniKorak = (long)numericUpDown2.Value;
			Form1.gKonstanta =  (float)numericUpDown3.Value;
			Form1.smerGravSile =  (int)numericUpDown4.Value;
			Form1.silaCirculalWall = (float)numericUpDown5.Value;
			Form1.radijCirculalWall =  (int)numericUpDown6.Value;
		
		}


		

		

		
	}
}
