/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace symmetry
{
	/// <summary>
	/// Summary description for Set_corner.
	/// </summary>
	public class Test_data : System.Windows.Forms.Form
	{
		public int squareIndex=0, calcIndex=0, bord=0;
		private bool mouseDown = false, presentR=false;
		private int objectDrawn, counter2 = 0, brn;
		private double ugodnoS;
		private Point lastPoint = Point.Empty, ptR;
		private Graphics g;
		private Pen p, pG;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private Stroke1 oneSt =  new Stroke1();
		private Strokes1 allSt = new Strokes1();
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem9;
		private ArrayList diffCorner1 = new ArrayList(); //tabela spodnjih kvadratov
		private ArrayList diffCorner2 = new ArrayList();//tabela zgornjih  kvadratov 
		//private ArrayList diffLines = new ArrayList();	//naklon crte
		private int indexOfCorner = 0;
		private Point p1 = new Point();
		private Point p2 = new Point();
		private ArrayList l1 = new ArrayList();//tabeli v kateri shranimo  premice, ki oznaujejo kote
		private ArrayList rectangle1 = new ArrayList();	
		private ArrayList rectangle2 = new ArrayList();	
		private Recognizer r = new Recognizer();
		private System.ComponentModel.IContainer components;
		private HiPerfTimer clock1 = new HiPerfTimer();
		private HiPerfTimer clock2 = new HiPerfTimer();
		private System.Windows.Forms.Button button1;  //urca
		private double timer=0;
		private int LastScroll_V = 0;
		private int LastScroll_H = 0;
		private SetAttributes saT= new SetAttributes();
		private System.Windows.Forms.TrackBar trackBar2;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private double Cprob;
		private System.Windows.Forms.VScrollBar vScrollBar1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.HScrollBar hScrollBar1;
		private int Cdist;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Label label3;
		public static double distance=30; //razdalja za merge distance
		public static int subdivisionDistance=14; //razdalja v tockah za subdivision
		public static int subSampleSize=3; //stevilo tock, ki jih subdivision obdeluje na enkrat
		public static ArrayList blazList= new ArrayList();
		public static bool drawShape=false;
		public static int circleLimit = 6; //mejna vrednost za standardno deviacijo
		public static int curveLimit = 10; //meja ki pove ali je krivulja (brez kotov) ravna crta ali ne

		//spremenljivke za pomik 'cornerja' (desni miskin gumb)
		private static bool rightButtonDown=false;
		private static Point rightButtonDownPoint;
		private static int indexAll=-1,indexSq=-1;
		private static bool addCornerButton = false;
        
		//seznam konstant za sile
		public static float omejitevHitrosti = 0.001f; 
		public static long   casovniKorak = 100;
		public static float gKonstanta = -1.0f;
		public static int	smerGravSile = 90;
		public static float silaCirculalWall = 15.0f;
		//private System.Windows.Forms.MenuItem menuItem22;
		public static float   radijCirculalWall = 5f;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button button2;
		public static int pen_width=2;
		private System.Windows.Forms.CheckBox checkBox2;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.RadioButton radioButton3;
		private System.Windows.Forms.RadioButton radioButton4;

		//spremenljivke za 'useTheForce'
		public static int forceDistance=40;
				

		public Test_data()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.button1 = new System.Windows.Forms.Button();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.trackBar2 = new System.Windows.Forms.TrackBar();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.vScrollBar1 = new System.Windows.Forms.VScrollBar();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label5 = new System.Windows.Forms.Label();
			this.checkBox2 = new System.Windows.Forms.CheckBox();
			this.button2 = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.radioButton4 = new System.Windows.Forms.RadioButton();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.radioButton3 = new System.Windows.Forms.RadioButton();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.panel3 = new System.Windows.Forms.Panel();
			this.hScrollBar1 = new System.Windows.Forms.HScrollBar();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar2)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel1.Location = new System.Drawing.Point(16, 144);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(5000, 5000);
			this.panel1.TabIndex = 15;
			this.panel1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseUp);
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			this.panel1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseMove);
			this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem8,
																					  this.menuItem9,
																					  this.menuItem4});
			this.menuItem1.Text = "File";
			this.menuItem1.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 0;
			this.menuItem8.Text = "New";
			this.menuItem8.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 1;
			this.menuItem9.Text = "-";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Exit";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click_1);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(24, 88);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(80, 24);
			this.button1.TabIndex = 4;
			this.button1.Text = "Clear";
			this.button1.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// trackBar1
			// 
			this.trackBar1.Location = new System.Drawing.Point(8, 16);
			this.trackBar1.Maximum = 20;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(144, 42);
			this.trackBar1.TabIndex = 6;
			this.trackBar1.Value = 15;
			this.trackBar1.Scroll += new System.EventHandler(this.track_bar1_scroll);
			// 
			// trackBar2
			// 
			this.trackBar2.Location = new System.Drawing.Point(288, 8);
			this.trackBar2.Maximum = 30;
			this.trackBar2.Minimum = 1;
			this.trackBar2.Name = "trackBar2";
			this.trackBar2.Size = new System.Drawing.Size(144, 42);
			this.trackBar2.TabIndex = 7;
			this.trackBar2.Value = 15;
			this.trackBar2.Visible = false;
			this.trackBar2.Scroll += new System.EventHandler(this.track_bar2_scroll);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(296, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(152, 16);
			this.label1.TabIndex = 8;
			this.label1.Text = "Distance between corners";
			this.label1.Visible = false;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(40, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 16);
			this.label2.TabIndex = 9;
			this.label2.Text = "Corner sensitivity";
			// 
			// vScrollBar1
			// 
			this.vScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.vScrollBar1.LargeChange = 200;
			this.vScrollBar1.Location = new System.Drawing.Point(592, 140);
			this.vScrollBar1.Maximum = 4800;
			this.vScrollBar1.Name = "vScrollBar1";
			this.vScrollBar1.Size = new System.Drawing.Size(16, 289);
			this.vScrollBar1.SmallChange = 100;
			this.vScrollBar1.TabIndex = 11;
			this.vScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vScrollBar1_scroll);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.checkBox2);
			this.groupBox1.Controls.Add(this.button2);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.textBox1);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.checkBox1);
			this.groupBox1.Controls.Add(this.radioButton4);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.trackBar2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.trackBar1);
			this.groupBox1.Controls.Add(this.radioButton1);
			this.groupBox1.Controls.Add(this.radioButton2);
			this.groupBox1.Controls.Add(this.radioButton3);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Location = new System.Drawing.Point(0, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(5000, 128);
			this.groupBox1.TabIndex = 12;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Izbira parametrov";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(208, 52);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 16);
			this.label5.TabIndex = 16;
			this.label5.Text = "show corner";
			// 
			// checkBox2
			// 
			this.checkBox2.Checked = true;
			this.checkBox2.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox2.Location = new System.Drawing.Point(184, 48);
			this.checkBox2.Name = "checkBox2";
			this.checkBox2.Size = new System.Drawing.Size(16, 24);
			this.checkBox2.TabIndex = 15;
			this.checkBox2.Text = "checkBox2";
			this.checkBox2.CheckedChanged += new System.EventHandler(this.show_corners_click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(544, 72);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(48, 40);
			this.button2.TabIndex = 14;
			this.button2.Text = "Add corner";
			this.button2.Visible = false;
			this.button2.Click += new System.EventHandler(this.add_corner_click);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(520, 40);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(88, 16);
			this.label4.TabIndex = 13;
			this.label4.Text = "merge distance";
			this.label4.Visible = false;
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(464, 40);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(48, 20);
			this.textBox1.TabIndex = 12;
			this.textBox1.Text = "30";
			this.textBox1.Visible = false;
			this.textBox1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.text_box_press);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(208, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 16);
			this.label3.TabIndex = 11;
			this.label3.Text = "animate";
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(184, 24);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(16, 16);
			this.checkBox1.TabIndex = 10;
			this.checkBox1.Text = "checkBox1";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.conect_corners_click);
			// 
			// radioButton4
			// 
			this.radioButton4.Location = new System.Drawing.Point(256, 88);
			this.radioButton4.Name = "radioButton4";
			this.radioButton4.Size = new System.Drawing.Size(88, 24);
			this.radioButton4.TabIndex = 5;
			this.radioButton4.Text = "Show all";
			this.radioButton4.Visible = false;
			// 
			// radioButton1
			// 
			this.radioButton1.Location = new System.Drawing.Point(328, 88);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(80, 24);
			this.radioButton1.TabIndex = 1;
			this.radioButton1.Text = "Coloring";
			this.radioButton1.Visible = false;
			// 
			// radioButton2
			// 
			this.radioButton2.Location = new System.Drawing.Point(432, 88);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(80, 24);
			this.radioButton2.TabIndex = 2;
			this.radioButton2.Text = "Coloring 2";
			this.radioButton2.Visible = false;
			// 
			// radioButton3
			// 
			this.radioButton3.Location = new System.Drawing.Point(160, 88);
			this.radioButton3.Name = "radioButton3";
			this.radioButton3.Size = new System.Drawing.Size(90, 24);
			this.radioButton3.TabIndex = 3;
			this.radioButton3.Text = "Show corner";
			this.radioButton3.Visible = false;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 445);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(608, 16);
			this.statusBar1.TabIndex = 13;
			this.statusBar1.Text = "statusBar1";
			// 
			// panel3
			// 
			this.panel3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel3.BackColor = System.Drawing.Color.Silver;
			this.panel3.Location = new System.Drawing.Point(16, 429);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(592, 16);
			this.panel3.TabIndex = 14;
			// 
			// hScrollBar1
			// 
			this.hScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.hScrollBar1.BackColor = System.Drawing.Color.White;
			this.hScrollBar1.LargeChange = 200;
			this.hScrollBar1.Location = new System.Drawing.Point(16, 429);
			this.hScrollBar1.Maximum = 4700;
			this.hScrollBar1.Name = "hScrollBar1";
			this.hScrollBar1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.hScrollBar1.Size = new System.Drawing.Size(577, 15);
			this.hScrollBar1.SmallChange = 100;
			this.hScrollBar1.TabIndex = 12;
			this.hScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hScrollBar1_scroll);
			// 
			// Test_data
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 461);
			this.Controls.Add(this.hScrollBar1);
			this.Controls.Add(this.panel3);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.vScrollBar1);
			this.Controls.Add(this.panel1);
			this.Menu = this.mainMenu1;
			this.Name = "Test_data";
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar2)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			refreshScreenF();
		}

		private void narisiObjekte1()
		{
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.FromName("Black"));
				p.Width = 2;
				p.EndCap = System.Drawing.Drawing2D.LineCap.Round;
				p.LineJoin = LineJoin.Round;
				this.Controls.Add(panel1);
			}
		}

		private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right && checkBox1.Checked) // ce kliknemo z desnim miskinim gumbom
			{  //in ce smo v nacinu 'connect corners'
				double distanceToV;
				Stroke1 st1;
				Point pM = new Point(e.X,e.Y);

				for (int i=0; i < allSt.numberOfStrokes();i++) //pregledamo vse stroke, ce smo kliknili na katetega od kotov
				{
					st1=allSt.returnStrokeObject(i);
					for (int j=0; j < st1.markedCornersL.Count; j++)
					{
						distanceToV=pointDistance((Point)st1.markedCornersL[j],(Point)pM);
						if (distanceToV < 10) 
						{
							rightButtonDownPoint=(Point)st1.markedCornersL[j];
							rightButtonDown=true;
							indexAll=i;
							indexSq=j;
							//Console.WriteLine("Smo v blizini tocke ({0},{1})!",rightButtonDownPoint.X,rightButtonDownPoint.Y);
						}
													
					} //for j
					
				} //for i
				//rightButtonDown=true;

			}
			else   
			{
				if (addCornerButton)  //dodamo novo tocko kota v markedCornersL (klik na gumb Add Corner)
				{
					double d2=0, d3=0;
					double distanceToV;
					double time1;
					int i1;
					bool distanceOK=true;
					Point pT,pTemp;

					int indexSh=-1, indexStroke=-1, indexSh2=-1;
					Stroke1 st1;
					Point pM = new Point(e.X,e.Y);
					pT=pM;

					d2=1000;
					for (int i=0; i < allSt.numberOfStrokes();i++) //pregledamo vse stroke
					{
						st1=allSt.returnStrokeObject(i);

						//d2=pointDistance((Point)st1.returnElement(0),(Point)pM);
						for (int j=0; j < st1.numberOfPoints(); j++) //pregledamo vse tocke
						{
							distanceToV=pointDistance((Point)st1.returnElement(j),(Point)pM);
							if (distanceToV<d2)  //vzamemo najblizjo pritisnjeni
							{ 
								d2=distanceToV; 
								indexSh=j; //indeksi tocke na katero smo 'mislili' klikniti
								indexStroke=i;
								pT=st1.returnElement(j); //tocka na katero smo 'mislili' klikniti
							}  //shranimo indexe
						} //for j
					
					} //for i
					if (d2 < 10) 
					{
						
						st1=allSt.returnStrokeObject(indexStroke);
						d3=1000;
						for (int k=0; k < st1.markedCornersL.Count; k++) //poiscemo najblizji kot
						{
							distanceToV=pointDistance((Point)st1.markedCornersL[k],(Point)pT);
							if (distanceToV<10) { distanceOK=false; break; }
							
							if (distanceToV<d3)  //iscemo najblizji kot 
							{ 
								d3=distanceToV; 
								indexSh2=k; //index najblizjega kota v seznami 'st1.markedCornersL'
							}  //shranimo najkrajso razdaljo
						}
						if (distanceOK) //ni v blizini kakega kota
						{
							//Console.WriteLine("Smo v blizini lika {0} ",i);
							if (findPoint((Point)st1.markedCornersL[indexSh2]))
							{
								i1=returnPointIndex((Point)st1.markedCornersL[indexSh2]);
								//Console.WriteLine("Izbrana tocka ima cas {0}, bliznja pa {1}",st1.returnTimeOfElement(indexSh), st1.returnTimeOfElement(i1));
								
							
								if (st1.returnTimeOfElement(indexSh) > st1.returnTimeOfElement(i1))
									indexSh2++;

								st1.markedCornersL.Insert(indexSh2,(Point)pT);
								p.Color=Color.Red;
								g.DrawRectangle(p,pM.X-5,pM.Y-5,10,10);
							}
						}
					} //if
				
				
					addCornerButton=false;
				}
				else  //sicer
				{
					mouseDown = true;

					//if(objectDrawn == 1)
					objectDrawn++;
			
					timer=0;  //tukej zanemo merit cajt
					clock1.Start();
				}
			}
			
		}

		private void panel1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if((lastPoint.Equals(Point.Empty))) 
				lastPoint = new Point(e.X,e.Y);
				
			if(mouseDown && (e.Button == MouseButtons.Left)) //&& (objectDrawn == 0))
			{
				Point pMousePos = new Point(e.X,e.Y);
				clock1.Stop(); //as vsake toke vnesemo v tabelo
			
				timer=timer+clock1.Duration;
				oneSt.addPoint(pMousePos,timer);  //dodamo tocko in cajt
				counter2++;

				//attrThread = new Thread(new ThreadStart(calculateAttributes));
				//attrThread.Start();
				//while (attrThread.IsAlive) {}

				r.getAngleS(oneSt,2);  //sprotno raunanje kota tock
				r.addRecog2000S(oneSt,15); //sprotno raunanje regresije
				r.getSpeedS(oneSt,3); //sprotno racunanje hitrosti
				
				if (oneSt.numberOfPoints()-1 == calcIndex) bord=calcIndex; //to vrednost spreminja samo funckija markSquare2
				
				calcR(oneSt);
				
				markSquareA(2);
				g.DrawLine(p,pMousePos,lastPoint);

				/*
				System.Console.WriteLine("");
				for (int i=0; i<oneSt.numberOfPoints();i++)
				{ 
					System.Console.WriteLine("{0}_ {1}",i,oneSt.returnRecognitionAll(i));

				}
		 */
				clock1.Start();  // akcija odvisna od izbranega radio gumba 
						
				


			} //if
			else if (rightButtonDown && (e.Button == MouseButtons.Right)) 
			{
				
				//pocistimo star del slike
				p.Color=Color.White;
				//g.DrawRectangle(p,rightButtonDownPoint.X-5,rightButtonDownPoint.Y-5,10,10);
				
				refreshScreen(indexAll,Color.White,Color.White);
				

				p.Color=Color.Cyan;

				Point pMousePos = new Point(e.X,e.Y);
				rightButtonDownPoint=pMousePos;
				allSt.returnStrokeObject(indexAll).markedCornersL[indexSq]=rightButtonDownPoint;

				refreshScreen(indexAll,Color.Black,Color.BlueViolet);
				//refreshScreen();
				
				
				
			} //else



			
			lastPoint = new Point(e.X,e.Y);

		}  

		private void panel1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Color barva;
			Stroke1 s1 = new Stroke1();
			Stroke1 sTemp = new Stroke1();
			Stroke1 sBetween = new Stroke1();
			int i1, i2,indexZ,indexK, ind1,ind2,u;
			PointF pF=new PointF();
			Point p1,p2;
			double d1;
			bool doTheForce=true;

			if(/*(objectDrawn == 0) &&*/ (mouseDown == true))
			{
				if (oneSt.numberOfPoints()>0) //vnose shranjujemo samo, ce se miska premakne 
				{
					Point pt1,pt2;
					objectDrawn ++;
					oneSt.addWidth(2);
					oneSt.addColor(p.Color);
					allSt.addStroke(oneSt);
                    
					addFirstLastSquare(); //v seznam kotov dodamo se prvo in zadnjo tocko
					//mergeCorners();
					
					
					for (int i=0; i < oneSt.markedCornersL.Count; i++) //robne tocke dodamo v nov stroke
					{
						if (findPoint((Point)oneSt.markedCornersL[i]))
						{
							i1=returnPointIndex((Point)oneSt.markedCornersL[i]);
							Point tocka = new Point(0,0);
							//Console.WriteLine("Izbrana tocka ima cas {0}, bliznja pa {1}",st1.returnTimeOfElement(indexSh), st1.returnTimeOfElement(i1));
							s1.addPoint(oneSt.returnElement(i1),oneSt.returnTimeOfElement(i1));
							
							//--------------------SILE------------------------------------------
										
						}
					}
					oneSt.clearPointRecognitionAll();
					oneSt.clearPointRecognition();
					oneSt.clearPointRecognitionAngle();
					oneSt.clearPointRecognitionSpeed();
                    
					r.getSpeed(oneSt,3); //hitrost
					r.getAngle(oneSt,2); //racunanje kota
					r.addRecog2000(oneSt,15);  //lin. regresija
					
					
					if (oneSt.markedCornersL.Count == 2) //ce imamo krivuljo
					{
						for (int k=0; k < oneSt.markedCornersL.Count; k++) //stare kote skopiramo v zacasen seznam
							oneSt.tempMCL.Add((Point)oneSt.markedCornersL[k]);
							
						doTheForce=false;
						if (returnMaxRec(oneSt, 0, oneSt.numberOfPoints()-1)) //ce je na tem odseku krivulja
						{
							oneSt.markedCornersL.Clear();
							//na razdalje 'subdivisionDistance' postavimo nove tocke
							for (int i=0; i < oneSt.numberOfPoints(); i = i + subdivisionDistance)
							{
								oneSt.markedCornersL.Add(oneSt.returnElement(i));
							}
							oneSt.markedCornersL.Add(oneSt.returnElement(oneSt.numberOfPoints()-1)); // + zadnja tocka
							//-----------------------------------------------------------------------------------

						
							i2=oneSt.numberOfPoints()%subdivisionDistance; //stevilo tock med zadnjima dvema izbranima tockama
							if (i2 < (int)(subdivisionDistance/4)) //ce sta tocki preblizu ju zdruzimo
							{
								//oneSt.markedCornersL[(oneSt.markedCornersL.Count-2)]=(Point)oneSt.markedCornersL[oneSt.markedCornersL.Count-1];
								i1=oneSt.markedCornersL.Count;
								if (i2 != 0) oneSt.markedCornersL.RemoveAt(i1-2); //odstranimo predzadnjo tocko
								subSampleSize = (int)(oneSt.numberOfPoints()/subdivisionDistance) + 1; //poleg 'izbranih' tock dodamo se zacetno tocko
							}
							else 
							{
								subSampleSize = (int)(oneSt.numberOfPoints()/subdivisionDistance) + 2;
							}
							//Console.WriteLine("sub: {0}, distance: {1} (ost:{2}", subSampleSize, subdivisionDistance,i2);
							if (oneSt.markedCornersL.Count >= subSampleSize) //rabimo vsaj toliko tock
								oneSt=subdivision(oneSt,3);						// za subdivision
							//drawShape=true;
						} //if je krivulja
					} // if  == 2   
					else //imamo navaden lik-------------------------------------------------------------------
					{	
						sBetween.markedCornersL.Clear();

						for (int k=0; k < oneSt.markedCornersL.Count; k++) //stare kote skopiramo v zacasen seznam
						{
							p1=(Point)oneSt.markedCornersL[k];
							oneSt.tempMCL.Add((Point)oneSt.markedCornersL[k]);
							sBetween.markedCornersL.Add((Point)oneSt.markedCornersL[k]);
							//Console.WriteLine("oneSt.mcl:{0},{1}",p1.X,p1.Y);
						}

						

						//sedaj je treba pogledat ce imamo kje v liku kako krivuljo----------------------------
						
						for (int j1 =0; j1 < oneSt.markedCornersL.Count-1; j1++) 
						{
							
							p1=(Point)oneSt.markedCornersL[j1];
							p2=(Point)oneSt.markedCornersL[j1+1];
							
							indexZ=returnPointIndexS(oneSt,p1);
							indexK=returnPointIndexS(oneSt,p2);

							Console.WriteLine("indexZ:{0}, indexK:{1},stevilo tock: {2}",indexZ,indexK,oneSt.numberOfPoints());
							if (indexZ == -1 || indexK == -1)
							{
								Console.WriteLine("tocke p1: {0},{1} in p2: {2},{3}",p1.X,p1.Y,p2.X,p2.Y);
							}
							
							if (indexZ < oneSt.numberOfPoints() && indexK < oneSt.numberOfPoints()) //indeki OK ?
							{	
								if (returnMaxRec(oneSt, indexZ, indexK)) //ce je na tem odseku krivulja
								{
									doTheForce=false;
									Console.WriteLine("Imamo krivuljo med tockama {0} in {1}",indexZ,indexK);
									
									sTemp.markedCornersL.Clear(); //vsakic bo drug seznam
									//sedaj je treba nafilat ustrezne tocke----------------------------------------
									
									//na razdalje 'subdivisionDistance' postavimo nove tocke
									for (u=indexZ; u <= indexK; u = u + subdivisionDistance)
									{
										sTemp.markedCornersL.Add(oneSt.returnElement(u));
									}
									if (u!=indexK) 
									{
										sTemp.markedCornersL.Add(oneSt.returnElement(indexK)); // + zadnja tocka
										subSampleSize=sTemp.markedCornersL.Count;
									}
									else subSampleSize=sTemp.markedCornersL.Count-1;

									//-----------------------------------------------------------------------------------
									
									if (sTemp.markedCornersL.Count >= subSampleSize) //rabimo vsaj toliko tock
										sTemp=subdivision(sTemp,3);
			
									
									for (int h2=0; h2 < sBetween.markedCornersL.Count; h2++) //poiscemo ustrezen indeks
									{
										if ((Point)sTemp.markedCornersL[0]==(Point)sBetween.markedCornersL[h2])
										{
											for (int h3 = 1; h3 < sTemp.markedCornersL.Count-1; h3++)
											{
												//p1=(Point)sTemp.markedCornersL[h3];
												sBetween.markedCornersL.Insert(h2+h3,(Point)sTemp.markedCornersL[h3]);
												//Console.WriteLine("xxx :{0},{1}",p1.X,p1.Y);											
											}
											break;
										}
									} //for h2
									
									//-----------------------------------------------------------------------------
								} //if returnMax=true
							} //if indeksi
							
							
						} //for j1
								
						oneSt.markedCornersL.Clear();
						for (int i3=0; i3 < sBetween.markedCornersL.Count; i3++)
						{
							//p1=(Point)sBetween.markedCornersL[i3];
							//Console.WriteLine("between: {0},{1}",p1.X,p1.Y);
							oneSt.markedCornersL.Add((Point)sBetween.markedCornersL[i3]);
						}
						
						//---------------use the force ---------------------------------
						
						if (doTheForce)
						{
							s1=useTheForce(s1); //zalaufamo sile
							for (int i=0; i < s1.numberOfPoints(); i++) //popravimo stroke 'oneSt' z novimi tockami
							{
								if (i < oneSt.markedCornersL.Count) //popravimo seznam 'markedCornersL'
								{ 
									oneSt.markedCornersL[i]=s1.returnElement(i);
								}
								else 
								{
									oneSt.markedCornersL.Add(s1.returnElement(i));
								}
							} //for
						}
						//-----------------------------------------------------------
						
					
					} //else imamo navaden lik
					//----------------------------------------------------------------------------

					oneSt=findCircle(oneSt);
					//refreshScreen();
					refreshScreenStroke(oneSt);
					

					drawShape=false;  //zastavica za krivuljo
					 
					/*
					oneSt.clearPointRecognitionAll();
					oneSt.clearPointRecognition();
					oneSt.clearPointRecognitionAngle();
					oneSt.clearPointRecognitionSpeed();
                    
					r.getSpeed(oneSt,3); //hitrost
					r.getAngle(oneSt,2); //racunanje kota
					r.addRecog2000(oneSt,15);  //lin. regresija
					*/
					
					double iRmax= 0,iSmax= 0;
					//p.Color = Color.DeepSkyBlue;
					for(int i = 0;i<oneSt.numberOfPoints();i++) //poberem max vrednosti
					{
						if (oneSt.returnRecognitionSpeed(i)>iSmax) iSmax=oneSt.returnRecognitionSpeed(i);
						if (oneSt.returnRecognition(i)>iRmax) iRmax=oneSt.returnRecognition(i);
						//System.Console.WriteLine("Regresija: {0}", oneSt.returnRecognition(i));
						/*if(oneSt.returnRecognitionAngle(i) > 70 && 	oneSt.returnRecognitionAngle(i)< 110 )
						{
							pt1 = oneSt.returnElement(i);
							g.DrawRectangle(p,pt1.X-10,pt1.Y-10,20,20);
						}
						*/
					}
                
					double zR,zS,zA;
					for(int i = 0;i<oneSt.numberOfPoints();i++) //izpolnim seznam 'pointRecognitionAll'
					{
						if (oneSt.returnRecognition(i)!=-2) zR=oneSt.returnRecognition(i)/iRmax;
						else zR=0;
                    
						if (oneSt.returnRecognitionAngle(i)!=-1) //predpostavim da je kot 90 stopinj idealen kot!!!!!
						{
							if (oneSt.returnRecognitionAngle(i)<=90) zA=oneSt.returnRecognitionAngle(i)/90;
							else zA=1-(oneSt.returnRecognitionAngle(i)-90)/90;
							/*zA=1-oneSt.returnRecognitionAngle(i)/180; 
							System.Console.WriteLine("Za pri kotu {0} znaa tono: {1}",oneSt.returnRecognitionAngle(i),zA);*/
							
						}
						else zA=0;
                    
						if (oneSt.returnRecognitionSpeed(i)!=-1) zS=1-(oneSt.returnRecognitionSpeed(i)/iSmax);
						else zS=0;

						//System.Console.WriteLine("hitrost(0-1): {0}",zS);   

						oneSt.addRecognitionAll((zR+zS+zA)/3);
						//oneSt.addRecognitionAll(zS);
					} //for
					/*
					System.Console.WriteLine("");
					for (int i=0; i<oneSt.numberOfPoints();i++)
					{ 
						System.Console.WriteLine("{0}_ {1}",i,oneSt.returnRecognitionAll(i));

					}
					
					System.Console.WriteLine("Nova zadelva!");*/
					//pt1=oneSt.returnElement(0);
					p.Width=8;
					if (radioButton1.Checked) 
					{
						for(int i = 1;i < oneSt.numberOfPoints();i++) //izracunamo odtenek in pobarvamo stroke
						{
							pt1=oneSt.returnElement(i-1);
							if (oneSt.returnRecognitionAll(i)>=0 && oneSt.returnRecognitionAll(i) <=1)
							{
								barva=returnColor(oneSt.returnRecognitionAll(i));
								p.Color=barva;
							}
							else 
							{ 
								p.Color=Color.White;
								System.Console.WriteLine("Vrednost tocke {0} ni na intervalu (0,1)!!!",oneSt.returnRecognitionAll(i));
							}
					
							pt2=oneSt.returnElement(i);
							g.DrawLine(p,pt1,pt2); //stroke barvani na koncu
							//pt1=oneSt.returnElement(i);
						}  //for 
					} //if

					//this.timer1.Start();
					
				}//ifN
			}  //if
			mouseDown = false;
			counter2=0;  //stevec pobranih tock se resetira
			presentR=false; //prav tako ta spremenljivka
			brn=-1;    //tudi ta
			
			oneSt= new Stroke1(); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
			squareIndex=0;
			calcIndex=0;
			bord=0;

			p.Width = 2;
			//allSt.clearStrokes();
			//allSt = new Strokes1();
			//oneSt = new Stroke1();
			//objectDrawn++;

			if (rightButtonDown) 
			{
				rightButtonDown=false;
				//v seznam markedSquareL vstavimo novo lokacijo premicnega kota
				allSt.returnStrokeObject(indexAll).markedCornersL[indexSq]=rightButtonDownPoint; 
			}

		}
		
		private Color returnColor(double dC)  //vrnemo barvo glede na argument (med 0 in 1)
		{
			Color c1;
			
			double bluefunc,bluefunc2,redfunc,redfunc2,cgre;
			 
			bluefunc = 1.0 / (1.0 + Math.Exp(-10*(dC-0.6)));
			redfunc =  1.0 / (1.0 + Math.Exp(10*(dC-0.5)));
			   
			redfunc2 = 1.0 / (1.0 + Math.Exp(10*(dC-0.4)));
			bluefunc2 = 1.0 / (1.0 + Math.Exp(-10*(dC-0.75)));

			cgre =  1 - Math.Pow(redfunc2,2) - bluefunc2;
			   
			//dobljene vrednosti so na intervalu (0,1), tako da jih je potrebno se pomnoziti
			redfunc=redfunc*256; //inteval od 0 do 256 !!!
			cgre=cgre*256;
			bluefunc=bluefunc*256;

			c1=Color.FromArgb((int)redfunc,(int)cgre, (int)bluefunc);
			
			return c1;
		}
		
		


		private void menuItem1_Popup(object sender, System.EventArgs e)//poprava mainMenu
		{
			lastPoint = Point.Empty;
		}


		private void menuItem8_Click(object sender, System.EventArgs e)//File -> New
		{
			//Line line = new Line();	

			g.Clear(Color.White);
			
			p.Width = 2;
			allSt.clearStrokes();
			allSt = new Strokes1();
			oneSt = new Stroke1();
			objectDrawn = 0;
						

		
		}

		private void menuItem7_Click(object sender, System.EventArgs e)//File -> Next
		{
			
			this.changeDisplay();
		}
	
		public void changeDisplay()
		{
			Line line = new Line();	
	
			//g.Clear(Color.White);
			
			if(indexOfCorner < 2)
				indexOfCorner++;
			else
				indexOfCorner = 0;
           
			p.Color = Color.FromName("Black");
			p.Width = 2;
			oneSt = new Stroke1();
			objectDrawn = 0;
		}


		private void menuItem4_Click_1(object sender, System.EventArgs e)//File -> Exit
		{
			Test_data.ActiveForm.Close();
		}

		private Point whereIsCorner()
		{
			int i ;
			int Max = 0;
			Line le = new Line();
		
            
			Max = 0;
			
			for(i = 0 ;i < oneSt.numberOfPoints();i++)
			{
				if(le.distancToPoint(oneSt.returnElement(i))  > Max)
				{
					Max = le.distancToPoint(oneSt.returnElement(i));
					p1 = oneSt.returnElement(i);
				}

			}
		
			
			//p.Color = Color.Blue;
			//g.DrawEllipse(p,p1.X-15,p1.Y-15,30,30);
		              	
			return p1;

		}
		
		public Recognizer returnRecognizer()
		{
			return r;
		}

		/*

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			this.changeDisplay();
			//this.timer1.Stop();
		}

		*/

		private void markSquare(int distance)   //oznacimo kvadtatek
		{
			int i1,madMax=0;  //index kjer je najvecja verjetnost za kot
			for (i1=0; i1<oneSt.numberOfPoints();i1++)  //poiscemo max element in ga okvadratimo
				if ((oneSt.returnRecognitionAll(i1)>oneSt.returnRecognitionAll(madMax)) && oneSt.returnRecognitionAll(i1)<=1)
					madMax=i1;
            
			//System.Console.WriteLine("Najvecja vrednost je {0}",oneSt.returnRecognitionAll(madMax));
			if (!presentR) //prvic risemo
			{
				ugodnoS=oneSt.returnRecognitionAll(madMax);  //ta tocka bo trenutni kot (vrednost)
				presentR=true; //kvadratek je narisan
				ptR = oneSt.returnElement(madMax);
				p.Color=Color.Gold;
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				brn=madMax; //index novega kota
				p.Color=Color.FromName("Black");
			}
			else if (oneSt.returnRecognitionAll(madMax)>ugodnoS && oneSt.returnRecognitionAll(madMax)<=1)
			{	//nova najboljsa vrednost
				//ce najdemo boljse ujemanje, narisemo nov kvadratek in prejsnega zbrisemo

				ugodnoS=oneSt.returnRecognitionAll(madMax);
				p.Color=Color.FromName("White");
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				p.Color=Color.Black; //
				if (brn-10<0) i1=0;
				else i1=brn-10;

				for (int i=i1; (i<brn+10&&i<counter2-distance-1); i++)  //obnovimo prekinjeno krivuljo (counter je stevec pobranih tock)
					g.DrawLine(p,oneSt.returnElement(i),oneSt.returnElement(i+1));
				narisiObjekte1(); //ni nujno (za lepsi izris)

				brn=madMax; //nov index kvadratka
				ptR=oneSt.returnElement(brn);
				p.Color=Color.FromName("Gold");
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				p.Color=Color.FromName("Black");
			}

		} //markSquare

		public void calcR(Stroke1 oneSt) //izracunamo seznam pointRecognitionAll
		{
			double iRmax= 0,iSmax= 0;
			double zR,zS,zA;
			//int rr;
			//if (oneSt.numberOfPoints()-neighbor-1<0) rr=0;
			//else rr=oneSt.numberOfPoints()-neighbor-1;
            
			//oneSt.clearPointRecognitionAll();

			for(int i = bord;i<oneSt.numberOfPoints();i++) //poberem max vrednosti (je treba gledat zmer cel interval)
			{                                           //ker imamo verjetnost kota
				if (oneSt.returnRecognitionSpeed(i)>iSmax) iSmax=oneSt.returnRecognitionSpeed(i);
				if (oneSt.returnRecognition(i)>iRmax) iRmax=oneSt.returnRecognition(i);
			}
			//System.Console.WriteLine("Stevilo tock:{0}",oneSt.numberOfPoints());
			for(int i = bord;i<oneSt.numberOfPoints();i++) //izpolnim seznam 'pointRecognitionAll'
			{
				if (oneSt.returnRecognition(i)!=-2) zR=oneSt.returnRecognition(i)/iRmax;
				else zR=0;
                    
				if (oneSt.returnRecognitionAngle(i)!=-1) 
				{
					//if (oneSt.returnRecognitionAngle(i)<=90) zA=oneSt.returnRecognitionAngle(i)/90;
					if (oneSt.returnRecognitionAngle(i)<=90) zA=1;
					else zA=1-(oneSt.returnRecognitionAngle(i)-90)/90;
					
				}
				else zA=0;
                    
				if (oneSt.returnRecognitionSpeed(i)!=-1) zS=1-(oneSt.returnRecognitionSpeed(i)/iSmax);
				else zS=0;

				//System.Console.WriteLine("hitrost(0-1): {0}",zS);   
				
				if (i>=oneSt.numberOfPoints()-1)
					oneSt.addRecognitionAll((zR+zS+zA)/3);
				else oneSt.ChangeRecognitionAll((zR+zS+zA)/3,i);
				//if (!(oneSt.returnRecognitionAll(i)==oneSt.returnRecognitionAll(i)))
				//	System.Console.WriteLine("zR:{0},zA:{1},zS:{2}",zR,zA,zS);
				

				//System.Console.WriteLine("sprotna:{0} od({1})",oneSt.returnRecognitionAll(i),i);
				
			} //for
			/*			System.Console.WriteLine("");
						for (int i=0; i<oneSt.numberOfPoints();i++)
						{ 
							System.Console.WriteLine("{0}__ {1}",i,oneSt.returnRecognitionAll(i));

						}
			*/
		} //calcR

		public void chooseC(Point pMousePos,Point lastPoint) //fuckcija za radio button
		{
			if (radioButton3.Checked) 
			{
				markSquare(2);  //oznacimo tocko, ki je potencialni kot
				g.DrawLine(p,pMousePos,lastPoint);
			}
			else if (radioButton2.Checked) 
			{
				p.Width=7;
				for (int iC=0; iC < oneSt.numberOfPoints()-1;iC++) //sproti barvamo vnos
				{
					pMousePos=oneSt.returnElement(iC);
					lastPoint=oneSt.returnElement(iC+1);
					if (oneSt.returnRecognitionAll(iC+1)>=0 && oneSt.returnRecognitionAll(iC+1) <=1)
						p.Color=returnColor(oneSt.returnRecognitionAll(iC));
					else 
					{
						p.Color=Color.Black;
						//System.Console.WriteLine("Vrednost tocke {0} ni na intervalu (0,1)!!!",iC);
					}
					g.DrawLine(p,pMousePos,lastPoint);
				} //for
				p.Color=Color.Black;
				p.Width=2;
			}
			else if (radioButton1.Checked) 
				g.DrawLine(p,pMousePos,lastPoint);
			else if (radioButton4.Checked) 
			{
				markSquareA(2);
				g.DrawLine(p,pMousePos,lastPoint);
			}
			

		} //chooseC
		
		private void markSquareA(int distance)   //oznacimo kvadtatek in vrnemo indeks tocke, kjer je ta kvadratek
		{
			int i1,madMax=0;  //index kjer je najvecja verjetnost za kot
			
			//returnA(saN);
			

			for (i1=calcIndex; i1<oneSt.numberOfPoints();i1++)   //poiscemo max element in ga okvadratimo
			{
				if ((oneSt.returnRecognitionAll(i1)>oneSt.returnRecognitionAll(madMax)) && oneSt.returnRecognitionAll(i1)<=1)
					madMax=i1; //najdemo najbolj verjeten kot na nekem predelu
											
			}
			
			if (oneSt.returnRecognitionAll(madMax)>Cprob) 
			{   
				//System.Console.WriteLine("Verjetnost v tocki {0} je {1}",madMax,oneSt.returnRecognitionAll(madMax));
				//narisemo kvadratek
				calcIndex=madMax+Cdist; //naslednjih tock ne bo kota!
				squareIndex=madMax; //index kota
				//ugodnoS=oneSt.returnRecognitionAll(madMax);  //ta tocka bo trenutni kot (vrednost)
				//presentR=true; //kvadratek je narisan
				ptR = oneSt.returnElement(madMax);
				p.Color=Color.Gold;
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				//brn=madMax; //index novega kota
				p.Color=Color.FromName("Black");
				oneSt.markedCornersL.Add(ptR); //shranimo kvadratke
			}	
			
			
		} //markSquare

		
		public void SetLimit(SetAttributes sa)
		{
			saT=sa;
		}

		private void track_bar2_scroll(object sender, System.EventArgs e)  //nastavitve za drsnik
		{
			Cdist=trackBar2.Value;
			//Console.WriteLine("razdalja: {0}",Cdist);
			statusBar1.Text="Corner distance: " + Cdist + "points";
		}

		private void track_bar1_scroll(object sender, System.EventArgs e)
		{
			Cprob=trackBar1.Value*0.05;
			statusBar1.Text="Corner sensitivity: " + Cprob;
			//Console.WriteLine("verjetnost: {0}", Cprob);
		}

		private void hScrollBar1_scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			Point poi = new Point(panel1.Location.X - e.NewValue+ LastScroll_H ,panel1.Location.Y);
			poi.X = this.panel1.Location.X - e.NewValue + LastScroll_H;// - e.NewValue + LastScroll_H;
			poi.Y = this.panel1.Location.Y;
			LastScroll_H = e.NewValue; 
			panel1.Location = poi;
			//Console.WriteLine("pomik znaa: {0}",e.NewValue);

		}

		private void vScrollBar1_scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			Point poi = new Point();
			poi.X = this.panel1.Location.X;
			poi.Y = this.panel1.Location.Y -e.NewValue+ LastScroll_V;
			LastScroll_V = e.NewValue;
			panel1.Location = poi;
			//Console.WriteLine("pomik znaa: {0}",e.NewValue);
		}
		
		//-------------------------------------metode za premikanje tock---------------------------------
		private void addFirstLastSquare()
		{
			Point pt1;
			oneSt.markedCornersL.Insert(0,oneSt.returnElement(0));
			oneSt.markedCornersL.Add(oneSt.returnElement(oneSt.numberOfPoints()-1));
			
			pt1=(Point)oneSt.markedCornersL[0];
					
			p.Color=Color.Gold;
			g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
			pt1=(Point)oneSt.markedCornersL[oneSt.markedCornersL.Count-1];
			g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);

			p.Color=Color.Black;

		}

		public double pointDistance(Point p1,Point p2)
		{
			return Math.Sqrt(Math.Pow(p2.X-p1.X,2)+Math.Pow(p2.Y-p1.Y,2));
		} 

		private void mergeCorners()
		{
			double d1;
			Stroke1 st1,st2;
			int i1;

			for (int e=0; e < allSt.numberOfStrokes(); e++) 
			{
				st1=allSt.returnStrokeObject(e);
				for (int f=e; f < allSt.numberOfStrokes(); f++) //ni treba da vse like pregledujemo dvakrat
				{
					st2=allSt.returnStrokeObject(f);

					for (int i=0; i< st1.markedCornersL.Count; i++)
					{
						for (int j=0; j< st2.markedCornersL.Count; j++) //ni treba da vse tocke pregledujemo dvakrat
						{
							i1=st1.markedCornersL.Count-1;  //stevilo kotov pred brisanjem
                             
							d1=pointDistance((Point)st1.markedCornersL[i],(Point)st2.markedCornersL[j]);
							//Console.WriteLine("razdalja med {0}({1}) in {2}({3}) je: {4}",i,e,j,f,d1);
							if (distance >=d1 && st1.markedCornersL[i]!=st2.markedCornersL[j])  //zdruzim tocki i in j
							{
								//tocki postavimo skupaj 
								st2.markedCornersL[j]=st1.markedCornersL[i];

								if (st1==st2) 
								{
									st2.markedCornersL.RemoveAt(j); //ce primerjamo ista lika

									if ((i==0 && j==i1) || (j==0 && i==i1))
									{
										//st1.isConnected=true; //uporabljam pri checkIfForceApplied()
										//Console.WriteLine("Imamo nekaj");
									}
								} //if
								//Console.WriteLine("razdalja med {0} in {1} je: {2}",i,j,d1);
							} //if 
						} //for j
					} //for i
					//Console.WriteLine("");
				} //for f
			} //for e
		}

		private void conect_corners_click(object sender, System.EventArgs e)
		{
			//refreshScreenF(); 
		}
        
		
		//-------------------------------------------------------------------------------------------
		private void refreshScreen()
		{
			double d1;
			if (checkBox1.Checked || drawShape) 
			{
				Cdist=trackBar2.Value;
				Cprob=trackBar1.Value*0.05;
				if(objectDrawn == 0)
				{
					this.narisiObjekte1();
				}
				else 
				{
					g.Clear(Color.White);
					Point pt1, pt2;
					Stroke1 s1;
					p.Width=2;
					p.Color=Color.Black;
					
					for (int i=0; i<allSt.numberOfStrokes();i++) 
					{
						s1=allSt.returnStrokeObject(i);
						for (int j=0; j < s1.markedCornersL.Count-1; j++)
						{
						
							pt1=(Point)s1.markedCornersL[j];
							pt2=(Point)s1.markedCornersL[j+1];
							g.DrawLine(p,pt1,pt2); 
						}
						/*if (s1.isConnected) 
						{
							pt1=(Point)s1.markedCornersL[0];
							pt2=(Point)s1.markedCornersL[s1.markedCornersL.Count-1];
							g.DrawLine(p,pt1,pt2);
						}*/
						for (int k=0; k < s1.markedCornersL.Count; k++) 
						{
							if (!drawShape)
							{
								pt1=(Point)s1.markedCornersL[k];
					
								p.Color=Color.Green;
								g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
							}
						}
						p.Color=Color.FromName("Black");
					} //for
				
					p.Color=Color.FromName("Black");
				} //else
				p.Color=Color.Black;
			}  //if 
			else if(oneSt.isCircle) //'temp' narisemo krog
			{
				p.Color=Color.Green;
				d1=(int)oneSt.radius;
				g.DrawEllipse(p,(int)(oneSt.cPoint.X-d1),(int)(oneSt.cPoint.Y-d1),(int)(2*d1),(int)(2*d1));
				//g.DrawRectangle(p,oneSt.cPoint.X-5,oneSt.cPoint.Y-5,10,10);
				p.Color=Color.Black;
			}
			else 
			{
				Cdist=trackBar2.Value;
				Cprob=trackBar1.Value*0.05;
				if(objectDrawn == 0)
				{
					this.narisiObjekte1();
				}
				else 
				{
					g.Clear(Color.White);
					Point pt1, pt2;
					Stroke1 s1;
					p.Width=2;
					p.Color=Color.Black;
					for (int i=0; i<allSt.numberOfStrokes();i++) 
					{
						s1=allSt.returnStrokeObject(i);
						for (int j=0; j < s1.numberOfPoints()-1; j++)
						{
						
							pt1=s1.returnElement(j);
							pt2=s1.returnElement(j+1);
							g.DrawLine(p,pt1,pt2); 
						}
						for (int k=0; k < s1.markedCornersL.Count; k++) 
						{
							
							pt1=(Point)s1.markedCornersL[k];
					
							p.Color=Color.Gold;
							g.DrawRectangle(p,pt1.X-5,pt1.Y-5,5,5);
							
						}
						p.Color=Color.Black;
					}
				
					p.Color=Color.FromName("Black");
				} //else 
			} //else checked
		}

		private void refreshScreen(int strokeIndex, Color co, Color co1)
		{
			if (checkBox1.Checked) 
			{
				Cdist=trackBar2.Value;
				Cprob=trackBar1.Value*0.05;
				if(objectDrawn == 0)
				{
					this.narisiObjekte1();
				}
				else 
				{
					//g.Clear(Color.White);
					Point pt1, pt2;
					Stroke1 s1;
					p.Width=2;
					p.Color=co;
					
					s1=allSt.returnStrokeObject(strokeIndex);
					for (int j=0; j < s1.markedCornersL.Count-1; j++)
					{
						
						pt1=(Point)s1.markedCornersL[j];
						pt2=(Point)s1.markedCornersL[j+1];
						g.DrawLine(p,pt1,pt2); 
					}
					if (s1.isConnected) 
					{
						pt1=(Point)s1.markedCornersL[0];
						pt2=(Point)s1.markedCornersL[s1.markedCornersL.Count-1];
						g.DrawLine(p,pt1,pt2);
					}
					for (int k=0; k < s1.markedCornersL.Count; k++) 
					{
						pt1=(Point)s1.markedCornersL[k];
					
						p.Color=co1;
						g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
					
					}
					p.Color=Color.FromName("Black");
					
				
					p.Color=Color.FromName("Black");
				} //else
				p.Color=Color.Black;
			}  //if 
			else 
			{
				Cdist=trackBar2.Value;
				Cprob=trackBar1.Value*0.05;
				if(objectDrawn == 0)
				{
					this.narisiObjekte1();
				}
				else 
				{
					g.Clear(Color.White);
					Point pt1, pt2;
					Stroke1 s1;
					p.Width=2;
					p.Color=co;
					
					s1=allSt.returnStrokeObject(strokeIndex);
					for (int j=0; j < s1.numberOfPoints()-1; j++)
					{
						
						pt1=s1.returnElement(j);
						pt2=s1.returnElement(j+1);
						g.DrawLine(p,pt1,pt2); 
					}
					for (int k=0; k < s1.markedCornersL.Count; k++) 
					{
						pt1=(Point)s1.markedCornersL[k];
					
						p.Color=Color.Gold;
						g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
					
					}
					p.Color=Color.Black;
					
				
					p.Color=Color.FromName("Black");
				} //else 
			} //else checked
		}

		private void refreshScreen(Stroke1 s1)
		{
			
			Cdist=trackBar2.Value;
			Cprob=trackBar1.Value*0.05;
			if(objectDrawn == 0)
			{
				this.narisiObjekte1();
			}
			else 
			{
				g.Clear(Color.White);
				Point pt1, pt2;
					
				p.Width=2;
				p.Color=Color.Black;
					
				//s1=allSt.returnStrokeObject(strokeIndex);
				for (int j=0; j < s1.numberOfPoints()-1; j++)
				{
						
					pt1=(Point)s1.returnElement(j);
					pt2=(Point)s1.returnElement(j+1);
					p.Color=Color.Black;
					g.DrawLine(p,pt1,pt2); 
					p.Color=Color.Aquamarine;
					g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
				}
				pt2=(Point)s1.returnElement(s1.numberOfPoints()-1);
				g.DrawRectangle(p,pt2.X-5,pt2.Y-5,10,10);
				/*
					if (s1.isConnected) 
					{
						pt1=(Point)s1.markedCornersL[0];
						pt2=(Point)s1.markedCornersL[s1.markedCornersL.Count-1];
						g.DrawLine(p,pt1,pt2);
					}
				*/
				p.Color=Color.FromName("Black");
			} //else
			p.Color=Color.Black;
		}

		public void refreshScreenF()
		{
			Cdist=trackBar2.Value;
			Cprob=trackBar1.Value*0.05;
			if(objectDrawn == 0)
			{
				this.narisiObjekte1();
			}
			else 
			{
				g.Clear(Color.White);
				Point pt1, pt2;
				Stroke1 s1;	
				p.Width=2;
				double d1;
				
				for (int i=0; i < allSt.numberOfStrokes(); i++)
				{
					
					s1=allSt.returnStrokeObject(i);
					p.Color=Color.Black;
					if (s1.isCircle) //ce imamo sluajno krog
					{	
						d1=(int)s1.radius;
						g.DrawEllipse(p,(int)(s1.cPoint.X-d1),(int)(s1.cPoint.Y-d1),(int)(2*d1),(int)(2*d1));
					}
					else //navaden lik
					{
						p.Color=Color.Black;
						for (int j=0; j < s1.markedCornersL.Count-1; j++)
						{
							p.Color=Color.Black;
							pt1=(Point)s1.markedCornersL[j];
							pt2=(Point)s1.markedCornersL[j+1];
							g.DrawLine(p,pt1,pt2); 
						}
						if (checkBox2.Checked)
						{
							p.Color=Color.DarkRed;
							for (int k=0; k < s1.markedCornersL.Count; k++) 
							{
								pt1=(Point)s1.markedCornersL[k];
								g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
							}
						}
					
					} //nimamo kroga
				} //for i	

			} //else
			p.Color=Color.Black;
				
		}

		public void refreshScreenStroke(Stroke1 s1)
		{
			HiPerfTimer delay = new HiPerfTimer();
			Cdist=trackBar2.Value;
			Cprob=trackBar1.Value*0.05;
			double time=0,d1;
			
			if (checkBox1.Checked)
			{
				delay.Start();
				while (time < 1)
				{
					delay.Stop();
					time=time+delay.Duration;
					delay.Start();
				}
				delay.Stop(); time=0;
			}
			 
				
			
			if(objectDrawn == 0)
			{
				this.narisiObjekte1();
			}
			else 
			{

				Point pt1, pt2;
				p.Width=2;

				if (s1.isCircle)
				{
					if (checkBox1.Checked)
					{
						delay.Start();  //casovni zamik
						while (time < 1)
						{
							delay.Stop();
							time=time+delay.Duration;
							delay.Start();
						}
						delay.Stop(); time=0;
					}
					p.Color=Color.White;
					for (int k=0; k < s1.numberOfPoints()-1; k++) //pobrisemo oeiginalen stroke
					{
						pt1=(Point)s1.returnElement(k);
						pt2=(Point)s1.returnElement(k+1);
						g.DrawLine(p,pt1,pt2);
					}
					for (int k=0; k < s1.tempMCL.Count; k++)
					{
						pt1=(Point)s1.tempMCL[k];
						g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
					}
					for (int k=0; k < s1.tempMCL.Count; k++)
					{
						pt1=(Point)s1.tempMCL[k];
						g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
					}
					p.Color=Color.Black;
					d1=(int)s1.radius;
					g.DrawEllipse(p,(int)(s1.cPoint.X-d1),(int)(s1.cPoint.Y-d1),(int)(2*d1),(int)(2*d1));
					goto end1;
				}
				
				
				
				p.Color=Color.DarkRed;
				for (int k=0; k < s1.markedCornersL.Count; k++) 
				{
					pt1=(Point)s1.markedCornersL[k];
					g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
				}	
				if (checkBox1.Checked)
				{
					delay.Start();  //casovni zamik
					while (time < 1)
					{
						delay.Stop();
						time=time+delay.Duration;
						delay.Start();
					}
					delay.Stop(); time=0;
				}

				p.Color=Color.White;
				for (int k=0; k < s1.numberOfPoints()-1; k++) //pobrisemo oeiginalen stroke
				{
					pt1=(Point)s1.returnElement(k);
					pt2=(Point)s1.returnElement(k+1);
					g.DrawLine(p,pt1,pt2);
				}
				p.Color=Color.White;
				for (int k=0; k < s1.tempMCL.Count; k++)
				{
					pt1=(Point)s1.tempMCL[k];
					g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
				}

				if (checkBox2.Checked) 
				{
					p.Color=Color.DarkRed;
					for (int k=0; k < s1.markedCornersL.Count; k++) 
					{
						pt1=(Point)s1.markedCornersL[k];
						g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
					}
				}
				else 
				{
					p.Color=Color.White;
					for (int k=0; k < s1.markedCornersL.Count; k++) 
					{
						pt1=(Point)s1.markedCornersL[k];
						g.DrawRectangle(p,pt1.X-5,pt1.Y-5,10,10);
					}
				}

				p.Color=Color.Black;
				for (int k=0; k < s1.markedCornersL.Count-1; k++)
				{
					pt1=(Point)s1.markedCornersL[k];
					pt2=(Point)s1.markedCornersL[k+1];
					g.DrawLine(p,pt1,pt2);
				}
				
				
			} //else
			end1:
				p.Color=Color.Black;
			
		}

		private void text_box_press(object sender, System.Windows.Forms.KeyEventArgs e)
		{     
			try 
			{
				distance=System.Convert.ToDouble(textBox1.Text);
			}
			catch 
			{
				Console.WriteLine("Napaen vnos v polje 'merge distance'!");
			}
			  
		}

		private void add_corner_click(object sender, System.EventArgs e)
		{
			statusBar1.Text="Left click on the stroke to add new corner!";
			addCornerButton=true;
		}

		private bool findPoint(Point p1)
		{
			Stroke1 str1;
			bool vrni=false;

			for (int i=0; i < allSt.numberOfStrokes();i++)
			{
				str1=allSt.returnStrokeObject(i);
				for (int j=0; j < str1.numberOfPoints(); j++)
				{
					if (str1.returnElement(j)==p1)
						vrni=true;
				}
			}
			return vrni;
		}

		private int returnPointIndex(Point p1)
		{
			Stroke1 str1;
			int i1=-1;

			for (int i=0; i < allSt.numberOfStrokes();i++)
			{
				str1=allSt.returnStrokeObject(i);
				for (int j=0; j < str1.numberOfPoints(); j++)
				{
					if (str1.returnElement(j)==p1)
						i1=j;
				}
			}
			return i1;
		}

		private int returnPointIndexS(Stroke1 s1,Point p1)
		{
			int i1=-1;

			
			for (int j=0; j < s1.numberOfPoints(); j++)
			{
				if (s1.returnElement(j)==p1)
					i1=j;
			}
			
			return i1;
		}
		
		private Stroke1 useTheForce(Stroke1 st1) //realizacija privlacne sile najblizje dolzine
		{
			Vector v1,v2,v3;
			Point pt1 = new Point();
			int cornerNumber=st1.numberOfPoints(); //stevilo kotov, kot jih najde recognizer
			
			//Stroke1 sPom = new Stroke1();
			v1 = new Vector();
			v2 = new Vector();
			v3 = new Vector();
			double d1=0,forceD=0, diff=0, d2,d3;
			//vsaka tocka ima svoje polje (obmocja) v katerem vpliva na vse ostale tocke
			
			
			for (int i=0; i < st1.numberOfPoints(); i++)
			{
				//spremenljivaD=st1.numberOfPoints();
				for (int j=0; j < st1.numberOfPoints(); j++)
				{
				
					if (i!=j) 
					{
						d1=pointDistance(st1.returnElement(i),st1.returnElement(j));
						if (d1<distance) //potlej i pa j zdruzimo v eno tocko (j leti ven)
						{
							//Console.WriteLine("Tocki {0} in {1} sta cisto skupaj",i,j);
						
							//st1.removePoint(j);
							st1.changePoint(st1.returnElement(i),j);
							if (i==0 && j==st1.numberOfPoints()-1) st1.isConnected=true; //tukaj se lik sklene
							//spremenljivaD--;
						}
						if (i==j-1 || i == j+1) 
						{
							//d1=pointDistance(st1.returnElement(i),st1.returnElement(j)); 
							forceD=d1%forceDistance;
											
							if (forceD > forceDistance/2) //premik gre stran od tocke (narazen)
							{
								diff=forceDistance-forceD; //dejanska razdalja (0 do 5 se po podaljsala razdalja med tockama)
								forceD=forceD-(forceDistance/2);
								forceD=forceD*20; //razpon (0,100)
							}
							else //premik gre proti tocki (skupaj)
							{
								diff=-forceD; //tocka se bosta zblizali za vrednost diff (je negativna)
								forceD=100-forceD * 20; //s tako silo vpliva i na j
								forceD=-forceD; // razpon (-100,0)
							}
							//sedaj premaknemo tocko 'j' tolikor kolikor ima vplivna tocka se energije
							//funkcija( tockaVpliva, tockaVplivana, razdaljaPremika);
					
							v1.Set(st1.returnElement(i).X,st1.returnElement(i).Y,0);
							v2.Set(st1.returnElement(j).X,st1.returnElement(j).Y,0);
							//Console.WriteLine("i znasa: ({0},{1}), j pa ({2},{3})",v1.X,v1.Y,v2.X,v2.Y); 
							v3 = v2 - v1; //to je vektor ko se zacne v st1 in konca v st2
							//Console.WriteLine("razlika med {0} in {1} znasa: ({2},{3}), dolzina: {4}",i,j,v3.X,v3.Y, v3.DistanceFrom());
				    
							if (v3.DistanceFrom()!=0) 
							{
								d2=(v3.DistanceFrom() + diff)/v3.DistanceFrom(); //vrednost med 0 in 1
							}
							else { Console.Error.WriteLine("Error: Vector size is zero!"); d2=0; }
							//Console.WriteLine("Nova razdalja: {0}", d2);
							v3 = v3 * (float)d2;
							//Console.WriteLine("nova razlika med {0} in {1} znasa: ({2},{3}), dolzina: {4}",i,j,v3.X,v3.Y, v3.DistanceFrom());
					
							v2= v1 + v3;
							//Console.WriteLine("Nove tocke za j so: {0} in {1}",v2.X,v2.Y);
							pt1.X=(int)v2.X;
							pt1.Y=(int)v2.Y;
							st1.changePoint(pt1,j);  //tocko smo prestavili !!!!!!!!!!!!!!!!!!!
					
							//Console.WriteLine("Nasa nova tocka je: ({0},{1})",st1.returnElement(j).X, st1.returnElement(j).Y);
							//-------------------
						}
					} //if i != j
				
					//Console.WriteLine("razdalja med {0} in {1} je: {2}({3})",i,j,d1,forceD);
				} //for j
				
			} //for i
			Point point1,point2;
			Point point3 = new Point(0,0);
			for (int i=0; i < st1.numberOfPoints();i++) //pogledamo ce si tocke podobne v kateri od koordinat -> jih poglihamo
			{
				point1=st1.returnElement(i);
				for (int j=0; j < st1.numberOfPoints();j++)
				{
					point2=st1.returnElement(j);
					if (i!=j)
					{
						if (Math.Abs(point1.X-point2.X)<distance)
						{
							point2.X=point1.X;
							st1.changePoint(point2,j); //dejansko popravimo lik
						}
						if (Math.Abs(point1.Y-point2.Y)<distance)
						{
							point2.Y=point1.Y;
							st1.changePoint(point2,j);
						}
					} //if
				} //for j
			} //for i

			/*Console.WriteLine("");
				for (int k=0; k < st1.numberOfPoints(); k++)
					Console.WriteLine("Tocka: ({0},{1})", st1.returnElement(k).X,st1.returnElement(k).Y);*/
			
			return st1;
		}  
        
		//------------------------------funkcije za sile -----------------------------------------------
		
		
		public static Stroke1 subdivision(Stroke1 str1, int numOfLoops)
		{
			ArrayList subList = new ArrayList();
			ArrayList newList = new ArrayList();
			ArrayList tempList = new ArrayList();
			ArrayList returnList = new ArrayList();
			PointF pt1,pt2,ptT,pF = new PointF();
			Point pI1 = new Point();
			Point pI2 = new Point();
			Point pItemp = new Point();

			double dX,dY;
			int insertIndex;
			//Console.WriteLine("Zaenjam subdivision");

			//subdivision delamo na nekaj tockah naenkrat
			for (int i1=0; i1 < str1.markedCornersL.Count - subSampleSize + 1; i1= i1 + subSampleSize -1)
			{
				subList.Clear();
				
				for (int k=i1; k < i1 + subSampleSize; k++) //skopiramo en del 'str1' v 'subList'
				{
					pItemp=(Point)str1.markedCornersL[k]; //ostr1 ima koordinate tock tipa 'int'
					pF.X=(float)pItemp.X; pF.Y=(float)pItemp.Y;
					subList.Add(pF);
				}

				for (int i2=0; i2 < numOfLoops; i2++) //stevilo ponovitev operacije 'subdivision'
				{
					//------------------prvic generiramo vmesne tocke--------------------------------------
					newList.Clear();
					for (int k=0; k < subList.Count; k++) //skopiramo 'subList' v  'newList'
						newList.Add((PointF)subList[k]);

					for (int k1=0; k1 < subList.Count-1; k1++) //'newList' je 'subList' z vmesnimi tockami
					{
						pt1=(PointF)subList[k1];
						pt2=(PointF)subList[k1+1];
						dX=(pt1.X + pt2.X)/2;
						dY=(pt1.Y + pt2.Y)/2;
						PointF tNew = new PointF((float)dX,(float)dY); //kreiramo novo vmesno tocko					

						for (insertIndex=0; insertIndex < newList.Count; insertIndex++) //poiscemo mesto v 'newList', kamor dodamo novo tocko
						{
							//konverzija********************
							pt1=(PointF)newList[insertIndex]; //tocke primerjamo do natancnosti integer
							pt2=(PointF)subList[k1];	
							pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
							pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;

							if (pI1==pI2) break;
						} //for k2
						newList.Insert(insertIndex+1,tNew); //v seznam 'newList' vstavimo novo tocko
					} //for k1 

					subList.Clear();
					for (int k=0; k < newList.Count; k++) //skopiramo 'newList' v subList' 
						subList.Add((PointF)newList[k]);

					//--------prvic generiramo tocke^^^^^^------------------------------------------------

					//--------drugo generiranje vmesnih tock----------------------------------------------
					
					newList.Clear();
					for (int k=0; k < subList.Count; k++) //skopiramo 'subList' v  'newList'
						newList.Add((PointF)subList[k]);

					for (int k1=0; k1 < subList.Count-1; k1++) //'newList' je 'subList' z vmesnimi tockami
					{
						pt1=(PointF)subList[k1];
						pt2=(PointF)subList[k1+1];
						dX=(pt1.X + pt2.X)/2;
						dY=(pt1.Y + pt2.Y)/2;
						PointF tNew = new PointF((float)dX,(float)dY); //kreiramo novo vmesno tocko					

						for (insertIndex=0; insertIndex < newList.Count; insertIndex++) //poiscemo mesto v 'newList', kamor dodamo novo tocko
						{
							//konverzija********************
							pt1=(PointF)newList[insertIndex];
							pt2=(PointF)subList[k1];
							pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
							pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;
							if (pt1==pt2) break;
						} //for k2
						newList.Insert(insertIndex+1,tNew); //v seznam 'newList' vstavimo novo tocko
					} //for k1 

					subList.Clear();
					for (int k=0; k < newList.Count; k++) //skopiramo 'newList' v 'subList' 
						subList.Add((PointF)newList[k]);
										
					//---------------drugo generiranje tock ^^^^^-------------------------------------------
					
					//---------------------pregled trojk----------------------------------------------------
					for (int k1=0; k1 < subList.Count-2; k1++) //pregledamo vse trojke v 'subList' in pregledamo vmesne tocke
					{
						pt1=(PointF)subList[k1];
						pt2=(PointF)subList[k1+2];
						dX=(pt1.X + pt2.X)/2;
						dY=(pt1.Y + pt2.Y)/2;
						PointF tNew = new PointF((float)dX,(float)dY); //kreiramo novo vmesno tocko
						
						pt1=tNew;
						pt2=(PointF)subList[k1+1];
						pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
						pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;
						
						if (pI1 != pI2) //nasli smo novo tocko !!
						{
							//sedaj iz seznama 'newList' brisemo tri in dodamo eno novo tocko	
							ptT=(PointF)subList[k1+1];
							//Console.WriteLine("Stara: ({0};{1}), nova: ({2};{3})",ptT.X,ptT.Y,tNew.X,tNew.Y);
							// 2. V 'newList' poiscemo tocke z indeksom 'k1','k1+1' in 'k1+2' in jih zbrisemo
							tempList.Clear();
							for (int k=0; k < newList.Count; k++) //pripravimo si pomozen seznam
								tempList.Add((PointF)newList[k]);

							for (int h=0; h < newList.Count-2; h++) //  spremenim 'newList' (DODAN nov pogoj!!)
							{
								pt1=(PointF)newList[h];
								pt2=(PointF)subList[k1];
								pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
								pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;

								if (pI1==pI2) //nasli smo jo
								{									
									newList.Insert(h,tNew);
									newList.RemoveAt(h+1);
									newList.RemoveAt(h+1);
									newList.RemoveAt(h+1);
									//tempList.RemoveAt(h);
									
									break;					
								}
								
							} //for h
							
						
						} //if nova vmesna tocka razlicna od stare
												
					} //for k1 (vse trojke v seznamu 'subList') -------------------------------------

					subList.Clear();
					for (int k=0; k < newList.Count; k++) //skopiramo 'newList' v 'subList' 
						subList.Add((PointF)newList[k]);
					
				} //for i2 - ponovitve za 'subdivision'
			
				for (int k=0; k < subList.Count; k++) //skopiramo 'subList' v koncno seznam
					returnList.Add((PointF)subList[k]);

			} //for i1 -> vsi skupki tock
			
			//-----------------------------------KONEC----------------------------------------------------
			
			str1.markedCornersL.Clear();
			for (int k=0; k < returnList.Count; k++) // 'returnList' skopiramo nazaj v 'markedCornersList'
			{
				pF=(PointF)returnList[k]; //konverzija iz tock 'float' v 'int'
				pItemp.X =(int)pF.X; pItemp.Y=(int)pF.Y;
				str1.markedCornersL.Add(pItemp);
			}
			//Console.WriteLine("Subdivision zakljuen!");
			return str1;
			
		} //subdivision
		
		//-------------------------------------------------------------------------------------------
		
		public Stroke1 findCircle(Stroke1 str1)
		{
			int iX=0,iY=0;
			Point t1;
			double averageD=0,averageV=0,d1;
	
			for (int i1=0; i1 < str1.numberOfPoints(); i1++) //izracunamo "povprecno" tocko
			{
				t1=str1.returnElement(i1);
				iX=iX + t1.X; iY=iY + t1.Y;
			}
			iX=(int)(iX/str1.numberOfPoints());
			iY=(int)(iY/str1.numberOfPoints());
			str1.cPoint.X=iX;
			str1.cPoint.Y=iY;

			for (int i1=0; i1 < str1.numberOfPoints(); i1++) //izracunamo povprecno oddaljenost tock od srediscne tocke
			{
				averageD=averageD +  pointDistance(str1.returnElement(i1),str1.cPoint);
			}
			averageD=averageD/str1.numberOfPoints();
			str1.radius=averageD;
			//Console.WriteLine("Srediscna tocka: {0},{1}",iX,iY);
			//Console.WriteLine("Povprecna razdalja je: {0}", averageD);
			
			for (int i1=0; i1 < str1.numberOfPoints(); i1++) //izracunamo povprecno odstopanje tock od povprecne oddaljenosti
			{
				d1=pointDistance(str1.returnElement(i1),str1.cPoint);
				averageV=averageV + (Math.Abs(averageD-d1));
			}
			averageV=averageV/str1.numberOfPoints();
			//Console.WriteLine("Povprecna oddaljenost od radija: {0} ",averageV);
			//circleLimit=(int)(averageD/6);
			if (averageV < circleLimit ) //ali stroke zadosca kriteriju za krog
			{
				
				d1=pointDistance((Point)str1.markedCornersL[0],(Point)str1.markedCornersL[str1.markedCornersL.Count-1]);
				if (d1 < distance) //ali sta prva in zadnja tocka zadosti skupaj
				{
					//Console.WriteLine("Imamo krog!");
					str1.isCircle=true;
				}
			}

			return str1;
		} //find circle

		//---------------------------------------------------------------------

		public bool returnMaxRec(Stroke1 s1, int indexZ, int indexK)
		{
			bool curve=false;
			//ArrayList retA= new ArrayList();
			indexZ=indexZ+10;
			indexK=indexK-10;

			if (indexZ < s1.numberOfPoints() && indexK > 0) //robnih tock ne pregledujemo
			{
			
				for (int i1=indexZ; i1 <= indexK; i1++)
				{
					if (s1.returnRecognition(i1)> curveLimit) 
					{
						curve=true;
						//Console.WriteLine("recog je: {0}",s1.returnRecognition(i1));
						break;
					}
				
				}
			}
			
			return curve;
		}

		private void show_corners_click(object sender, System.EventArgs e)
		{
			refreshScreenF();
		}

		
	}
	
}
